{ **************************************************************************** }
{ *                                                                          * }
{ * DONKEY KONG (Coleco) Simulator                                           * }
{ * by Luca "MADrigal" Antignano, September 2002 (revision: September 2022)  * }
{ *                                                                          * }
{ * http://www.madrigaldesign.it/sim/                                        * }
{ * lucantignano@gmail.com                                                   * }
{ *                                                                          * }
{ * This source code (the "Software") is released as "open source" under the * }
{ * "Creative Common Attribution-NonCommercial-ShareAlike" license 4.0       * }
{ * available at:                                                            * }
{ * https://creativecommons.org/licenses/by-nc-sa/4.0/legalcode              * }
{ *                                                                          * }
{ * In addition to the constraints set by the CC license, you must respect   * }
{ * the following rules:                                                     * }
{ * a. do not offer the Software on a pay-per-play basis.                    * }
{ * b. do not distribute the Software through pre-paid access websites or    * }
{ *    BBS's.                                                                * }
{ * c. do not use the Software in publications of any form unless written    * }
{ *    consent is obtained by the author.                                    * }
{ * d. do not distribute the Software through mirror websites, unless        * }
{ *    written consent is obtained by the author.                            * }
{ * e. do not distribute older versions of the Software through authorized   * }
{ *    mirror websites after newer ones have been made available by the      * }
{ *    author.                                                               * }
{ *                                                                          * }
{ * Excerpt from the CC BY-NC-SA license 4.0                                 * }
{ * ========================================                                 * }
{ * BY: You must give appropriate credit, provide a link to the license, and * }
{ *     indicate if changes were made. You may do so in any reasonable       * }
{ *     manner, but not in any way that suggests the licensor endorses you   * }
{ *     or your use.                                                         * }
{ * NC: You may not use the material for commercial purposes.                * }
{ * SA: If you remix, transform, or build upon the material, you must        * }
{ *     distribute your contributions under the same license as the          * }
{ *     original.                                                            * }
{ *                                                                          * }
{ **************************************************************************** }

unit unit1;
{ this unit contains the main form implementation                              }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, Registry, Jpeg, Pngimage, Fmod, Fmodtypes, StdCtrls, Menus,
  ShellAPI;

type
  TForm1 = class(TForm)
{ * HANDHELD GRAPHICS, INCLUDING BUTTONS                                     * }

    // fullscreen mode items
    btn_game_menu_top:        TImage;
    btn_game_menu_background: TImage;

    im_backdrop:              TImage;
    im_backdrop_logo:         TImage;

    // electronic game
    im_background:            TImage;       im_background_screen_top: TImage;
    im_background_screen_on:  TImage;

    btn_power_down:           TImage;       btn_power_top:            TImage;

    btn_joystick_bottom:      TImage;       btn_joystick_top:         TImage;
    btn_joystick_bottom_up:   TImage;       
    btn_joystick_bottom_down: TImage;
    btn_joystick_bottom_left: TImage;
    btn_joystick_bottom_right:TImage;


    btn_jump_down:            TImage;       btn_jump_top:             TImage;

    btn_ctrlr_overlay_up:     TImage;
    btn_ctrlr_overlay_left:   TImage;
    btn_ctrlr_overlay_right:  TImage;
    btn_ctrlr_overlay_down:   TImage;

{ * LCD SCREEN GRAPHICS (SPRITES)                                            * }

    // on-screen panel (score, digits)
    im_panel_digit_pos_1: TImage; im_panel_digit_pos_2: TImage; im_panel_digit_pos_3: TImage; im_panel_digit_pos_4: TImage; im_panel_digit_pos_5: TImage;

    im_panel_number_0: TImage; im_panel_number_1: TImage; im_panel_number_2: TImage; im_panel_number_3: TImage; im_panel_number_4: TImage;
    im_panel_number_5: TImage; im_panel_number_6: TImage; im_panel_number_7: TImage; im_panel_number_8: TImage; im_panel_number_9: TImage;

    im_panel_lives_1: TImage; im_panel_lives_2: TImage;

    im_panel_hiscore: TImage;

    im_panel_bonus: TImage;

    // on-screen items
    im_woman_1: TImage; im_woman_2: TImage;

    im_kong_1: TImage; im_kong_2: TImage; im_kong_3: TImage; im_kong_4: TImage;

    {                    }   {                    }   {                    }   {                    }   im_mario_05_11: TImage;  {                    }   {                    }
    im_mario_01_10: TImage;  im_mario_02_10: TImage;  im_mario_03_10: TImage;  {                    }   im_mario_05_10: TImage;  im_mario_06_10: TImage;  im_mario_07_10: TImage;
    im_mario_01_09: TImage;  im_mario_02_09: TImage;  im_mario_03_09: TImage;  im_mario_04_09: TImage;  im_mario_05_09: TImage;  im_mario_06_09: TImage;  im_mario_07_09: TImage;
    im_mario_01_08: TImage;  im_mario_02_08: TImage;  im_mario_03_08: TImage;  im_mario_04_08: TImage;  im_mario_05_08: TImage;  im_mario_06_08: TImage;  im_mario_07_08: TImage;
    im_mario_01_07: TImage;  im_mario_02_07: TImage;  im_mario_03_07: TImage;  im_mario_04_07: TImage;  im_mario_05_07: TImage;  im_mario_06_07: TImage;  im_mario_07_07: TImage;
    im_mario_01_06: TImage;  im_mario_02_06: TImage;  im_mario_03_06: TImage;  im_mario_04_06: TImage;  im_mario_05_06: TImage;  im_mario_06_06: TImage;  im_mario_07_06: TImage;
    im_mario_01_05: TImage;  im_mario_02_05: TImage;  im_mario_03_05: TImage;  im_mario_04_05: TImage;  im_mario_05_05: TImage;  im_mario_06_05: TImage;  im_mario_07_05: TImage;
    im_mario_01_04: TImage;  im_mario_02_04: TImage;  im_mario_03_04: TImage;  im_mario_04_04: TImage;  im_mario_05_04: TImage;  im_mario_06_04: TImage;  im_mario_07_04: TImage;
    im_mario_01_03: TImage;  im_mario_02_03: TImage;  im_mario_03_03: TImage;  im_mario_04_03: TImage;  im_mario_05_03: TImage;  im_mario_06_03: TImage;  im_mario_07_03: TImage;
    im_mario_01_02: TImage;  im_mario_02_02: TImage;  im_mario_03_02: TImage;  im_mario_04_02: TImage;  im_mario_05_02: TImage;  im_mario_06_02: TImage;  im_mario_07_02: TImage;
    im_mario_01_01: TImage;  im_mario_02_01: TImage;  im_mario_03_01: TImage;  im_mario_04_01: TImage;  im_mario_05_01: TImage;  im_mario_06_01: TImage;  im_mario_07_01: TImage;

    im_barrel_01_10: TImage; {                     }  {                     }  {                     }  im_barrel_05_10: TImage; {                     }  {                     }
    im_barrel_01_09: TImage; im_barrel_02_09: TImage; im_barrel_03_09: TImage; {                     }  im_barrel_05_09: TImage; im_barrel_06_09: TImage; im_barrel_07_09: TImage;
    {                     }  {                     }  im_barrel_03_08: TImage; {                     }  {                     }  {                     }  im_barrel_07_08: TImage;
    im_barrel_01_07: TImage; im_barrel_02_07: TImage; im_barrel_03_07: TImage; im_barrel_04_07: TImage; im_barrel_05_07: TImage; im_barrel_06_07: TImage; im_barrel_07_07: TImage;
    im_barrel_01_06: TImage; {                     }  {                     }  {                     }  im_barrel_05_06: TImage; {                     }  {                     }
    im_barrel_01_05: TImage; im_barrel_02_05: TImage; im_barrel_03_05: TImage; im_barrel_04_05: TImage; im_barrel_05_05: TImage; im_barrel_06_05: TImage; im_barrel_07_05: TImage;
    {                     }  {                     }  im_barrel_03_04: TImage; {                     }  {                     }  {                     }  im_barrel_07_04: TImage;
    im_barrel_01_03: TImage; im_barrel_02_03: TImage; im_barrel_03_03: TImage; im_barrel_04_03: TImage; im_barrel_05_03: TImage; im_barrel_06_03: TImage; im_barrel_07_03: TImage;
    im_barrel_01_02: TImage; {                     }  {                     }  {                     }  im_barrel_05_02: TImage; {                     }  {                     }
    im_barrel_01_01: TImage; im_barrel_02_01: TImage; im_barrel_03_01: TImage; im_barrel_04_01: TImage; im_barrel_05_01: TImage; im_barrel_06_01: TImage; im_barrel_07_01: TImage;

    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_flame_01_09: TImage;  im_flame_02_09: TImage;  im_flame_03_09: TImage;  {                    }   im_flame_05_09: TImage;  im_flame_06_09: TImage;  im_flame_07_09: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_flame_01_07: TImage;  im_flame_02_07: TImage;  im_flame_03_07: TImage;  im_flame_04_07: TImage;  im_flame_05_07: TImage;  im_flame_06_07: TImage;  im_flame_07_07: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_flame_01_05: TImage;  im_flame_02_05: TImage;  im_flame_03_05: TImage;  im_flame_04_05: TImage;  im_flame_05_05: TImage;  im_flame_06_05: TImage;  im_flame_07_05: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_flame_01_03: TImage;  im_flame_02_03: TImage;  im_flame_03_03: TImage;  im_flame_04_03: TImage;  im_flame_05_03: TImage;  im_flame_06_03: TImage;  im_flame_07_03: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_flame_01_01: TImage;  im_flame_02_01: TImage;  im_flame_03_01: TImage;  im_flame_04_01: TImage;  im_flame_05_01: TImage;  im_flame_06_01: TImage;  im_flame_07_01: TImage;

    im_stair_01_10: TImage;  {                    }   {                    }   {                    }   im_stair_05_10: TImage;  {                    }   {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   {                    }   im_stair_03_08: TImage;  {                    }   {                    }   {                    }   im_stair_07_08: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    im_stair_01_06: TImage;  {                    }   {                    }   {                    }   im_stair_05_06: TImage;  {                    }   {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   {                    }   im_stair_03_04: TImage;  {                    }   {                    }   {                    }   im_stair_07_04: TImage;
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   {                    }   {                    }   {                    }   im_stair_05_02: TImage;  {                    }   {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }

    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_hole_04_07: TImage;   {                   }    im_hole_06_07: TImage;   {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    im_hole_06_05: TImage;   {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_hole_04_03: TImage;   {                   }    im_hole_06_03: TImage;   {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    im_hole_06_01: TImage;   {                   }

    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   im_rivet_02_09: TImage;  {                    }   {                    }   {                    }   im_rivet_06_09: TImage;  {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   im_rivet_02_07: TImage;  {                    }   {                    }   {                    }   im_rivet_06_07: TImage;  {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   im_rivet_02_05: TImage;  {                    }   {                    }   {                    }   im_rivet_06_05: TImage;  {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   im_rivet_02_03: TImage;  {                    }   {                    }   {                    }   im_rivet_06_03: TImage;  {                    }
    {                    }   {                    }   {                    }   {                    }   {                    }   {                    }   {                    }
    {                    }   im_rivet_02_01: TImage;  {                    }   {                    }   {                    }   im_rivet_06_01: TImage;  {                    }

    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_item_04_08: TImage;   {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_item_04_06: TImage;   {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_item_04_04: TImage;   {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }    {                   }
    {                   }    {                   }    {                   }    im_item_04_02: TImage;

{ * TIMERS                                                                   * }
    Timer_Game_1:         TTimer;
    Timer_Game_2:         TTimer;
    Timer_Game_3:         TTimer;
    Timer_Game_Start:     TTimer;
    Timer_Mario_Move:     TTimer;
    Timer_Miss:           TTimer;
    Timer_Stage_Complete: TTimer;
    Timer_Time_Counter:   TTimer;
    Timer_Woman_Blink:    TTimer;

{ * POPUP MENU                                                               * }
    pm_0_menu:          TPopupMenu;
    pm_1_about:         TMenuItem;
    pm_2_readme:        TMenuItem;
    pm_3_whatsnew:      TMenuItem;
    pm_4_manual:        TMenuItem;
    pm_5_n1:            TMenuItem;
    pm_6_config:        TMenuItem;
    pm_7_keys:          TMenuItem;
    pm_8_hiscore:       TMenuItem;
    pm_9_n2:            TMenuItem;
  {}pm_10_fullscreen:   TMenuItem;
  {}pm_11_splashscreen: TMenuItem;
  {}pm_12_controller:   TMenuItem;
  {}pm_13_n3:           TMenuItem;
  {}pm_14_exit:         TMenuItem;

{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
    procedure FormCreate                    (Sender: TObject);
    procedure FormActivate                  (Sender: TObject);
    procedure FormClose                     (Sender: TObject; var Action: TCloseAction);

{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
    procedure Vid_Display_Ctrl_Overlay;

    procedure Vid_Show_All_Barrels          (b: boolean);
    procedure Vid_Show_All_Flames           (b: boolean);
    procedure Vid_Show_All_Holes            (b: boolean);
    procedure Vid_Show_All_Items            (b: boolean);
    procedure Vid_Show_All_Kong             (b: boolean);
    procedure Vid_Show_All_Mario            (b: boolean);
    procedure Vid_Show_All_Rivets           (b: boolean);
    procedure Vid_Show_All_Stairs           (b: boolean);

    procedure Vid_Show_Panel_Lives          (p: integer);
    procedure Vid_Show_Panel_Score          (var p: integer);

    procedure Vid_Show_Fireball             (p: integer);
    procedure Vid_Show_Item                 (p: integer; b: boolean);
    procedure Vid_Show_Mario                (b: boolean);
    procedure Vid_Show_Stairs               (s0502, s0304, s0704, s0106, s0506, s0308, s0708, s0110, s0510: boolean);
    procedure Vid_Show_Woman                (p: integer);

{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
    procedure Snd_Play                      (pfs: PFSoundSample);
    procedure Snd_Silence;

{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
    procedure im_backgroundMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure im_backgroundMouseMove        (Sender: TObject;                       Shift: TShiftState; X, Y: Integer);

    procedure btn_power_topMouseDown        (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_jump_topMouseDown         (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_jump_topMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure btn_ctrlr_overlay_upMouseDown (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_upMouseUp   (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_rightMouseDown(Sender:TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_rightMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_leftMouseDown(Sender:TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_leftMouseUp (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_downMouseDown(Sender:TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure btn_ctrlr_overlay_downMouseUp (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormKeyDown                   (Sender: TObject; var Key: Word;        Shift: TShiftState);
    procedure FormKeyUp                     (Sender: TObject; var Key: Word;        Shift: TShiftState);

{ * INPUT MANAGEMENT - ACTIONS                                               * }
    procedure Inp_power_down;

    procedure Inp_jump_down;                procedure Inp_jump_up;
    procedure Inp_left_down;                procedure Inp_left_up;
    procedure Inp_right_down;               procedure Inp_right_up;
    procedure Inp_up_down;                  procedure Inp_up_up;
    procedure Inp_down_down;                procedure Inp_down_up;

{ * PROCEDURES: GAME ROUTINES                                                * }
    procedure Gam_Stop_All_Timers;

    procedure Gam_Do_Miss;
    procedure Gam_Change_Stage;
    procedure Gam_Init_Stage;
    procedure Gam_Mario_Jumps_Left;
    procedure Gam_Mario_Jumps_Right;
    procedure Gam_Mario_Jumps_Up;
    procedure Gam_Mario_Moved;
    procedure Gam_Set_Mode;
    procedure Gam_Set_MoveCells;

    function  Gam_Check_Stair_Over_Mario:   boolean;
    function  Gam_Check_Stair_Under_Mario:  boolean;

{ * PROCEDURES: TIMERS                                                       * }
    procedure Timer_Game_1Timer             (Sender: TObject);
    procedure Timer_Game_2Timer             (Sender: TObject);
    procedure Timer_Game_3Timer             (Sender: TObject);
    procedure Timer_Game_StartTimer         (Sender: TObject);
    procedure Timer_Mario_MoveTimer         (Sender: TObject);
    procedure Timer_MissTimer               (Sender: TObject);
    procedure Timer_Stage_CompleteTimer     (Sender: TObject);
    procedure Timer_Time_CounterTimer       (Sender: TObject);
    procedure Timer_Woman_BlinkTimer        (Sender: TObject);

{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
    procedure pm_0_menuPopup                (Sender: TObject);
    procedure pm_1_aboutClick               (Sender: TObject);
    procedure pm_2_readmeClick              (Sender: TObject);
    procedure pm_3_whatsnewClick            (Sender: TObject);
    procedure pm_4_manualClick              (Sender: TObject);
    procedure pm_6_configClick              (Sender: TObject);
    procedure pm_7_keysClick                (Sender: TObject);
    procedure pm_8_hiscoreClick             (Sender: TObject);
  {}procedure pm_10_fullscreenClick         (Sender: TObject);
  {}procedure pm_11_splashscreenClick       (Sender: TObject);
  {}procedure pm_12_controllerClick         (Sender: TObject);
  {}procedure pm_14_exitClick               (Sender: TObject);

{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
    procedure btn_game_menu_topClick        (Sender: TObject);

    procedure la_menu_itemMouseEnter        (Sender: TObject);
    procedure la_menu_itemMouseLeave        (Sender: TObject);
    procedure la_menu_itemMouseUp           (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure Vid_Display_Game_Menu         (b: boolean);
end;

const
{ introduced for use with HH2 / now incorporated into main source }

  HH2_CONTENT_NAME    = 'Donkey Kong (Coleco)';
  HH2_CONTENT_AUTHOR  = 'Luca "MADrigal" Antignano';
  HH2_CONTENT_EMAIL   = 'lucantignano@gmail.com';
  HH2_CONTENT_VERSION = '5.01';
  HH2_CONTENT_DATE    = '2022/09/12';
  HH2_CONTENT_WEBSITE = 'www.madrigaldesign.it/sim';

  { constants for all builds }
  
  APP_NAME      = HH2_CONTENT_NAME + ' Simulator';                              // application's name (appears on taskbar and Splash screen)
{}APP_VERSION   = 'Version ' + HH2_CONTENT_VERSION + ' * Graphic improvements *'; // current version (appears on Splash screen)
{}APP_DATE      = 'Released by ' + HH2_CONTENT_AUTHOR + ' on 12th September, 2022'; // release date (appears on Splash screen)

  URL_EMAIL     = 'mailto:' + HH2_CONTENT_EMAIL;                                // link to the email address
  URL_PAYPAL    = 'https://www.paypal.me/LucaAntignano';                        // link to the Paypal donation page
  URL_WEBSITE   = 'http://' + HH2_CONTENT_WEBSITE + '/';                        // link to the website

  REG_KEY       = 'Software\MADrigal\DKongC50';                                 // registry key

  HINT_CLICK    = 'click or press';
  HINT_PWR_OFF  = 'to turn on the game';
  HINT_PWR_ON   = 'to turn off the game';
  HINT_JOYSTICK = 'activate the controller overlays or use';

{}MENU_ITEMS = 14;
  NUM_KEYS = 6;

var
{ * main objects * }
  Form1:                   TForm1;                                              // main form
  bStartup:                boolean;                                             // manages splash screen at startup
  iMouseX, iMouseY:        integer;                                             // cursor coordinates (to drag main form)
  iReg:                    TRegIniFile;                                         // system registry (to save high-scores)

{ * sound management * }
  pfs_bonus,
  pfs_button,
  pfs_complete,
  pfs_gameover,
  pfs_hurryup,
  pfs_jump,
  pfs_miss,
  pfs_power,
  pfs_start1,
  pfs_start2,
  pfs_step1,
  pfs_step2:               PFSoundSample;                                       // sound samples

  bSound:                  boolean;                                             // sound Enabled? (depending on selected driver on splash screen)

{ * arrays of images * }
  aIm_panel_digit_pos:     array[1..5]        of TImage;                        // empty sprites to host score/hiscore digits
  aIm_panel_number:        array[0..9]        of TImage;                        // digits for score/hiscore
  aIm_panel_lives:         array[1..2]        of TImage;                        // remaining lives
  aIm_barrels:             array[1..7, 1..10] of TImage;                        // barrels: x=horizontal; y=vertical
  aIm_flames:              array[1..7, 1..9]  of TImage;                        // flames:  x=horizontal; y=vertical
  aIm_stairs:              array[1..7, 1..10] of TImage;                        // stairs:  x=horizontal; y=vertical
  aIm_holes:               array[4..6, 1..7]  of TImage;                        // holes:   x=horizontal; y=vertical
  aIm_rivets:              array[2..6, 1..9]  of TImage;                        // rivets:  x=horizontal; y=vertical
  aIm_items:               array[2..8]        of TImage;                        // items:   x=vertical
  aIm_mario:               array[1..7, 1..11] of TImage;                        // Mario:   x=horizontal; y=vertical
  aIm_kong:                array[1..4]        of TImage;                        // Donkey Kong: 1=body; 2=hands down; 3=hands up; 4=barrel

{ * arrays of integers * }
  aFireballs:              array[1..3]        of record
                                                   iPosX,
                                                   iPosY : integer;
                                                 end;

  aMoveCells:              array[1..7, 1..10] of integer;                       // values
                                                                                // 1=L
                                                                                // 2=R   3=L+R
                                                                                // 4=D   5=L+D   6=R+D   7=L+R+D
                                                                                // 8=U   9=L+U  10=R+U  11=L+R+U  12=U+D

{ * arrays of mixed types *}
  aKeys:                   array[1..NUM_KEYS] of record                         // keys management (values)
                                                   int:  integer;
                                                   word: word;
                                                 end;

  aKeyHints:               array[1..44] of string;                              // keys management (hint on buttons)

  aMenuItem:               array[1..MENU_ITEMS] of TMenuItem;                   // popup menu items
  aMenuLabels:             array[1..MENU_ITEMS] of TLabel;                      // on-screen game menu labels

{ * integers and booleans * }
  iMarioX, iMarioY,                                                             // x=1-7; y=1-11
  iScore, iHiScore,                                                             // 0-998 (x 100)
  iBonusScore,                                                                  // 10-80 (x 100)
  iCurrentStage,                                                                // 1-?? (stairs layout loops at every 15 stages)
  iLives,                                                                       // 0-2
  iMode,                                                                        // 0=off; 1=on/demo; 2=on/game 3=on/game over
  iNextMove,
  iRivetsLeft                                                                   // 0-10
                         : integer;

{}bFullscreenMode,                                                              // true if video mode is fullscreen (false if "shaped game")
  bGameMenuOpen,                                                                // true if the on-screen menu is visible
  bDisplayCtrlOverlays,                                                         // true if the controller overlay should be displayed

  bController,
  bKeyPressedJump,
  bKeyPressedLeft,
  bKeyPressedRight,
  bKeyPressedUp,
  bKeyPressedDown
                         : boolean;

  // Game variables: loops
  iLoopGame1,
  iLoopGame3,
  iLoopKong,
  iLoopMarioMove,
  iLoopMiss,
  iLoopStageComplete,
  iLoopTimeCounter,
  iLoopWomanBlink
                         : integer;

implementation

uses
  about, gfxinit, keys, manual, splash;

{$r *.dfm}










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INITIALIZE & SHUT DOWN                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
{ sprites on form are associated to arrays of images, needed to "index" them   }
{ variables are initialized: system registry, randomize, game mode, etc.       }
  var
    i: integer;
begin
  // initializes application name (for Windows taskbar)
  Application.Title := APP_NAME;

{}// sets game off the screen while graphics initialise
{}Top  := - Screen.Height;
{}Left := - Screen.Width;

  { panel: score/hiscore/bonus, remaining lives }
  aIm_panel_digit_pos[1] := im_panel_digit_pos_1; aIm_panel_digit_pos[2] := im_panel_digit_pos_2; aIm_panel_digit_pos[3] := im_panel_digit_pos_3; aIm_panel_digit_pos[4] := im_panel_digit_pos_4; aIm_panel_digit_pos[5] := im_panel_digit_pos_5;

  aIm_panel_number[0] := im_panel_number_0; aIm_panel_number[1] := im_panel_number_1; aIm_panel_number[2] := im_panel_number_2; aIm_panel_number[3] := im_panel_number_3; aIm_panel_number[4] := im_panel_number_4;
  aIm_panel_number[5] := im_panel_number_5; aIm_panel_number[6] := im_panel_number_6; aIm_panel_number[7] := im_panel_number_7; aIm_panel_number[8] := im_panel_number_8; aIm_panel_number[9] := im_panel_number_9;

  aIm_panel_lives[1] := im_panel_lives_1; aIm_panel_lives[2] := im_panel_lives_2;

  { barrels }
  aIm_barrels[1, 10] := im_barrel_01_10; {                                  }  {                                  }  {                                  }  aIm_barrels[5, 10] := im_barrel_05_10; {                                  }  {                                  }
  aIm_barrels[1,  9] := im_barrel_01_09; aIm_barrels[2, 9] := im_barrel_02_09; aIm_barrels[3, 9] := im_barrel_03_09; {                                  }  aIm_barrels[5,  9] := im_barrel_05_09; aIm_barrels[6, 9] := im_barrel_06_09; aIm_barrels[7, 9] := im_barrel_07_09;
  {                                   }  {                                  }  aIm_barrels[3, 8] := im_barrel_03_08; {                                  }  {                                  }   {                                  }  aIm_barrels[7, 8] := im_barrel_07_08;
  aIm_barrels[1,  7] := im_barrel_01_07; aIm_barrels[2, 7] := im_barrel_02_07; aIm_barrels[3, 7] := im_barrel_03_07; aIm_barrels[4, 7] := im_barrel_04_07; aIm_barrels[5,  7] := im_barrel_05_07; aIm_barrels[6, 7] := im_barrel_06_07; aIm_barrels[7, 7] := im_barrel_07_07;
  aIm_barrels[1,  6] := im_barrel_01_06; {                                  }  {                                  }  {                                  }  aIm_barrels[5,  6] := im_barrel_05_06; {                                  }  {                                  }
  aIm_barrels[1,  5] := im_barrel_01_05; aIm_barrels[2, 5] := im_barrel_02_05; aIm_barrels[3, 5] := im_barrel_03_05; aIm_barrels[4, 5] := im_barrel_04_05; aIm_barrels[5,  5] := im_barrel_05_05; aIm_barrels[6, 5] := im_barrel_06_05; aIm_barrels[7, 5] := im_barrel_07_05;
  {                                   }  {                                  }  aIm_barrels[3, 4] := im_barrel_03_04; {                                  }  {                                  }   {                                  }  aIm_barrels[7, 4] := im_barrel_07_04;
  aIm_barrels[1,  3] := im_barrel_01_03; aIm_barrels[2, 3] := im_barrel_02_03; aIm_barrels[3, 3] := im_barrel_03_03; aIm_barrels[4, 3] := im_barrel_04_03; aIm_barrels[5,  3] := im_barrel_05_03; aIm_barrels[6, 3] := im_barrel_06_03; aIm_barrels[7, 3] := im_barrel_07_03;
  aIm_barrels[1,  2] := im_barrel_01_02; {                                  }  {                                  }  {                                  }  aIm_barrels[5,  2] := im_barrel_05_02; {                                  }  {                                  }
  aIm_barrels[1,  1] := im_barrel_01_01; aIm_barrels[2, 1] := im_barrel_02_01; aIm_barrels[3, 1] := im_barrel_03_01; aIm_barrels[4, 1] := im_barrel_04_01; aIm_barrels[5,  1] := im_barrel_05_01; aIm_barrels[6, 1] := im_barrel_06_01; aIm_barrels[7, 1] := im_barrel_07_01;

  { flames }
  aIm_flames[1, 9] := im_flame_01_09;    aIm_flames[2, 9] := im_flame_02_09;   aIm_flames[3, 9] := im_flame_03_09;   {                                  }  aIm_flames[5,  9] := im_flame_05_09;   aIm_flames[6, 9] := im_flame_06_09;   aIm_flames[7, 9] := im_flame_07_09;
  aIm_flames[1, 7] := im_flame_01_07;    aIm_flames[2, 7] := im_flame_02_07;   aIm_flames[3, 7] := im_flame_03_07;   aIm_flames[4, 7] := im_flame_04_07;   aIm_flames[5,  7] := im_flame_05_07;   aIm_flames[6, 7] := im_flame_06_07;   aIm_flames[7, 7] := im_flame_07_07;
  aIm_flames[1, 5] := im_flame_01_05;    aIm_flames[2, 5] := im_flame_02_05;   aIm_flames[3, 5] := im_flame_03_05;   aIm_flames[4, 5] := im_flame_04_05;   aIm_flames[5,  5] := im_flame_05_05;   aIm_flames[6, 5] := im_flame_06_05;   aIm_flames[7, 5] := im_flame_07_05;
  aIm_flames[1, 3] := im_flame_01_03;    aIm_flames[2, 3] := im_flame_02_03;   aIm_flames[3, 3] := im_flame_03_03;   aIm_flames[4, 3] := im_flame_04_03;   aIm_flames[5,  3] := im_flame_05_03;   aIm_flames[6, 3] := im_flame_06_03;   aIm_flames[7, 3] := im_flame_07_03;
  aIm_flames[1, 1] := im_flame_01_01;    aIm_flames[2, 1] := im_flame_02_01;   aIm_flames[3, 1] := im_flame_03_01;   aIm_flames[4, 1] := im_flame_04_01;   aIm_flames[5,  1] := im_flame_05_01;   aIm_flames[6, 1] := im_flame_06_01;   aIm_flames[7, 1] := im_flame_07_01;

  { stairs }
  aIm_stairs[1, 10] := im_stair_01_10;   {                                  }  {                                  }  {                                  }  aIm_stairs[5, 10] := im_stair_05_10;   {                                  }  {                                  }
  {                                  }   {                                  }  aIm_stairs[3, 8] := im_stair_03_08;   {                                  }  {                                  }   {                                  }  aIm_stairs[7, 8] := im_stair_07_08;
  aIm_stairs[1,  6] := im_stair_01_06;   {                                  }  {                                  }  {                                  }  aIm_stairs[5,  6] := im_stair_05_06;   {                                  }  {                                  }
  {                                  }   {                                  }  aIm_stairs[3, 4] := im_stair_03_04;   {                                  }  {                                  }   {                                  }  aIm_stairs[7, 4] := im_stair_07_04;
  {                                  }   {                                  }  {                                  }  {                                  }  aIm_stairs[5,  2] := im_stair_05_02;   {                                  }  {                                  }

  { holes }
  {                                  }   {                                  }  {                                  }  aIm_holes[4, 7] := im_hole_04_07;     {                                  }   aIm_holes[6, 7] := im_hole_06_07;     {                                  }
  {                                  }   {                                  }  {                                  }  {                                  }  {                                  }   aIm_holes[6, 5] := im_hole_06_05;     {                                  }
  {                                  }   {                                  }  {                                  }  aIm_holes[4, 3] := im_hole_04_03;     {                                  }   aIm_holes[6, 3] := im_hole_06_03;     {                                  }
  {                                  }   {                                  }  {                                  }  {                                  }  {                                  }   aIm_holes[6, 1] := im_hole_06_01;     {                                  }

  { rivets }
  {                                  }   aIm_rivets[2, 9] := im_rivet_02_09;   {                                  }  {                                  }  {                                  }   aIm_rivets[6, 9] := im_rivet_06_09;   {                                  }
  {                                  }   aIm_rivets[2, 7] := im_rivet_02_07;   {                                  }  {                                  }  {                                  }   aIm_rivets[6, 7] := im_rivet_06_07;   {                                  }
  {                                  }   aIm_rivets[2, 5] := im_rivet_02_05;   {                                  }  {                                  }  {                                  }   aIm_rivets[6, 5] := im_rivet_06_05;   {                                  }
  {                                  }   aIm_rivets[2, 3] := im_rivet_02_03;   {                                  }  {                                  }  {                                  }   aIm_rivets[6, 3] := im_rivet_06_03;   {                                  }
  {                                  }   aIm_rivets[2, 1] := im_rivet_02_01;   {                                  }  {                                  }  {                                  }   aIm_rivets[6, 1] := im_rivet_06_01;   {                                  }   

  { bonus items }
  {                                  }   {                                  }  {                                  }  aIm_items[8] := im_item_04_08;        {                                  }   {                                  }  {                                  }
  {                                  }   {                                  }  {                                  }  aIm_items[6] := im_item_04_06;        {                                  }   {                                  }  {                                  }
  {                                  }   {                                  }  {                                  }  aIm_items[4] := im_item_04_04;        {                                  }   {                                  }  {                                  }
  {                                  }   {                                  }  {                                  }  aIm_items[2] := im_item_04_02;        {                                  }   {                                  }  {                                  }

  { Mario }
  {                                  }   {                                  }  {                                  }  {                                  }  aIm_mario[5, 11] := im_mario_05_11;    {                                  }  {                                  }
  aIm_mario[1, 10] := im_mario_01_10;    aIm_mario[2, 10] := im_mario_02_10;   aIm_mario[3, 10] := im_mario_03_10;   {                                  }  aIm_mario[5, 10] := im_mario_05_10;    aIm_mario[6, 10] := im_mario_06_10;   aIm_mario[7, 10] := im_mario_07_10;
  aIm_mario[1,  9] := im_mario_01_09;    aIm_mario[2,  9] := im_mario_02_09;   aIm_mario[3,  9] := im_mario_03_09;   aIm_mario[4, 9] := im_mario_04_09;    aIm_mario[5,  9] := im_mario_05_09;    aIm_mario[6,  9] := im_mario_06_09;   aIm_mario[7,  9] := im_mario_07_09;
  aIm_mario[1,  8] := im_mario_01_08;    aIm_mario[2,  8] := im_mario_02_08;   aIm_mario[3,  8] := im_mario_03_08;   aIm_mario[4, 8] := im_mario_04_08;    aIm_mario[5,  8] := im_mario_05_08;    aIm_mario[6,  8] := im_mario_06_08;   aIm_mario[7,  8] := im_mario_07_08;
  aIm_mario[1,  7] := im_mario_01_07;    aIm_mario[2,  7] := im_mario_02_07;   aIm_mario[3,  7] := im_mario_03_07;   aIm_mario[4, 7] := im_mario_04_07;    aIm_mario[5,  7] := im_mario_05_07;    aIm_mario[6,  7] := im_mario_06_07;   aIm_mario[7,  7] := im_mario_07_07;
  aIm_mario[1,  6] := im_mario_01_06;    aIm_mario[2,  6] := im_mario_02_06;   aIm_mario[3,  6] := im_mario_03_06;   aIm_mario[4, 6] := im_mario_04_06;    aIm_mario[5,  6] := im_mario_05_06;    aIm_mario[6,  6] := im_mario_06_06;   aIm_mario[7,  6] := im_mario_07_06;
  aIm_mario[1,  5] := im_mario_01_05;    aIm_mario[2,  5] := im_mario_02_05;   aIm_mario[3,  5] := im_mario_03_05;   aIm_mario[4, 5] := im_mario_04_05;    aIm_mario[5,  5] := im_mario_05_05;    aIm_mario[6,  5] := im_mario_06_05;   aIm_mario[7,  5] := im_mario_07_05;
  aIm_mario[1,  4] := im_mario_01_04;    aIm_mario[2,  4] := im_mario_02_04;   aIm_mario[3,  4] := im_mario_03_04;   aIm_mario[4, 4] := im_mario_04_04;    aIm_mario[5,  4] := im_mario_05_04;    aIm_mario[6,  4] := im_mario_06_04;   aIm_mario[7,  4] := im_mario_07_04;
  aIm_mario[1,  3] := im_mario_01_03;    aIm_mario[2,  3] := im_mario_02_03;   aIm_mario[3,  3] := im_mario_03_03;   aIm_mario[4, 3] := im_mario_04_03;    aIm_mario[5,  3] := im_mario_05_03;    aIm_mario[6,  3] := im_mario_06_03;   aIm_mario[7,  3] := im_mario_07_03;
  aIm_mario[1,  2] := im_mario_01_02;    aIm_mario[2,  2] := im_mario_02_02;   aIm_mario[3,  2] := im_mario_03_02;   aIm_mario[4, 2] := im_mario_04_02;    aIm_mario[5,  2] := im_mario_05_02;    aIm_mario[6,  2] := im_mario_06_02;   aIm_mario[7,  2] := im_mario_07_02;
  aIm_mario[1,  1] := im_mario_01_01;    aIm_mario[2,  1] := im_mario_02_01;   aIm_mario[3,  1] := im_mario_03_01;   aIm_mario[4, 1] := im_mario_04_01;    aIm_mario[5,  1] := im_mario_05_01;    aIm_mario[6,  1] := im_mario_06_01;   aIm_mario[7,  1] := im_mario_07_01;

  { Donkey Kong }
  aIm_kong[1] := im_kong_1; aIm_kong[2] := im_kong_2; aIm_kong[3] := im_kong_3; aIm_kong[4] := im_kong_4;

  // registry keys management
  iReg := TregIniFile.Create(REG_KEY);                                          // system registry init

{}// init graphics
{}bFullscreenMode := iReg.ReadBool('', 'FullscreenMode', true);
{}pm_10_fullscreen.Checked := bFullscreenMode;
{}Gfxinit.Gfx_Game_Init;
{}bGameMenuOpen := false;

{}// initialises the "hints" array
  for i := 1 to 10 do
    aKeyHints[i] := '''' + Chr(i + 47) + '''';

  for i := 11 to 36 do
    aKeyHints[i] := '''' + Chr(i + 54) + '''';

  aKeyHints[37] := '''up arrow'' key';
  aKeyHints[38] := '''down arrow'' key';
  aKeyHints[39] := '''left arrow'' key';
  aKeyHints[40] := '''right arrow'' key';
  aKeyHints[41] := '''alt'' key';
  aKeyHints[42] := '''ctrl'' key';
  aKeyHints[43] := '''shift'' key';
  aKeyHints[44] := '''spacebar''';

  // reads values from system registry into the inputs array
  aKeys[1].int := iReg.ReadInteger('', 'Key1', 2);                              // "ON/OFF" (default: "1")
  aKeys[2].int := iReg.ReadInteger('', 'Key2', 37);                             // "Up"     (default: "UP")
  aKeys[3].int := iReg.ReadInteger('', 'Key3', 39);                             // "Left"   (default: "LEFT")
  aKeys[4].int := iReg.ReadInteger('', 'Key4', 40);                             // "Right"  (default: "RIGHT")
  aKeys[5].int := iReg.ReadInteger('', 'Key5', 38);                             // "Down"   (default: "DOWN")
  aKeys[6].int := iReg.ReadInteger('', 'Key6', 42);                             // "Jump"   (default: "CTRL")

  // writes values into the system registry (in case no pre-existing values
  // stored), then assigns key values to the key-inputs array
  for i := 1 to NUM_KEYS do
    begin
      iReg.WriteInteger('', 'Key' + inttostr(i), aKeys[i].int);
      KeysForm.AssignWord(i, aKeys[i].int);
    end;

  // sets button images hints
  btn_power_top.Hint           := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_PWR_OFF; // "Power off"

  btn_joystick_top.Hint        := HINT_JOYSTICK + ' ' + aKeyHints[aKeys[2].int] + ', '            // "Up"
                                                      + aKeyHints[aKeys[3].int] + ', '            // "Left"
                                                      + aKeyHints[aKeys[4].int] + ', '            // "Right"
                                                      + aKeyHints[aKeys[5].int];                  // "Down"

  btn_jump_top.Hint            := HINT_CLICK + ' ' + aKeyHints[aKeys[6].int];                     // "Jump"

  btn_ctrlr_overlay_up.Hint    := HINT_CLICK + ' ' + aKeyHints[aKeys[2].int];                     // "Up"
  btn_ctrlr_overlay_left.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[3].int];                     // "Left"
  btn_ctrlr_overlay_right.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[4].int];                     // "Right"
  btn_ctrlr_overlay_down.Hint  := HINT_CLICK + ' ' + aKeyHints[aKeys[5].int];                     // "Down"

  // popup menu array association
  aMenuItem[1]  := pm_1_about;
  aMenuItem[2]  := pm_2_readme;
  aMenuItem[3]  := pm_3_whatsnew;
  aMenuItem[4]  := pm_4_manual;
  aMenuItem[5]  := pm_5_n1;
  aMenuItem[6]  := pm_6_config;
  aMenuItem[7]  := pm_7_keys;
  aMenuItem[8]  := pm_8_hiscore;
  aMenuItem[9]  := pm_9_n2;
{}aMenuItem[10] := pm_10_fullscreen;
{}aMenuItem[11] := pm_11_splashscreen;
{}aMenuItem[12] := pm_12_controller;
{}aMenuItem[13] := pm_13_n3;
{}aMenuItem[14] := pm_14_exit;

  // controller overlay setting
{}pm_12_controller.Checked  := iReg.ReadBool('', 'CtrlrOverlay', true);
{}bDisplayCtrlOverlays := pm_12_controller.Checked;

  // controller overlay
  Vid_Display_Ctrl_Overlay;

  // variables init
  DoubleBuffered := true;

  iHiScore := iReg.ReadInteger('', 'HiScore1' , iHiScore);                      // reads value from system registry into iHiScore

  bKeyPressedJump  := false;
  bKeyPressedLeft  := false;
  bKeyPressedRight := false;
  bKeyPressedDown  := false;
  bKeyPressedUp    := false;
  bController      := false;

  Randomize;                                                                    // initializes the random number generator
end;





procedure TForm1.FormActivate(Sender: TObject);
{ sends focus to the splash screen at startup                                  }
begin
  if bStartup then
    begin
      bStartup := false;
      SplashForm.Show;
    end;
end;





procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
{ frees memory before shutting down                                            }
begin
  FSOUND_Sample_Free(pfs_bonus);    FSOUND_Sample_Free(pfs_button);
  FSOUND_Sample_Free(pfs_complete); FSOUND_Sample_Free(pfs_gameover);
  FSOUND_Sample_Free(pfs_hurryup);  FSOUND_Sample_Free(pfs_jump);
  FSOUND_Sample_Free(pfs_miss);     FSOUND_Sample_Free(pfs_power);
  FSOUND_Sample_Free(pfs_start1);   FSOUND_Sample_Free(pfs_start2);
  FSOUND_Sample_Free(pfs_step1);    FSOUND_Sample_Free(pfs_step2);

  FSOUND_Close;

{}iReg.Destroy;
  Action := caFree;
end;









{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: DISPLAY MANAGEMENT                                           * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Vid_Display_Ctrl_Overlay;
{ displays or hides the controller overlay images                              }
begin
  btn_ctrlr_overlay_up.Visible    := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_left.Visible  := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_right.Visible := bDisplayCtrlOverlays;
  btn_ctrlr_overlay_down.Visible  := bDisplayCtrlOverlays;
end;





procedure TForm1.Vid_Show_All_Barrels(b: boolean);
{ displays/hides all barrels                                                   }
  var
    i: integer;
begin
  for i := 1 to 7 do
    begin
      aIm_barrels[i, 1].Visible := b;
      aIm_barrels[i, 3].Visible := b;
      aIm_barrels[i, 5].Visible := b;
      aIm_barrels[i, 7].Visible := b;

      if i <> 4 then
        aIm_barrels[i, 9].Visible := b;
    end;

  aIm_barrels[1,  2].Visible := b;
  aIm_barrels[5,  2].Visible := b;
  aIm_barrels[3,  4].Visible := b;
  aIm_barrels[7,  4].Visible := b;
  aIm_barrels[1,  6].Visible := b;
  aIm_barrels[5,  6].Visible := b;
  aIm_barrels[3,  8].Visible := b;
  aIm_barrels[7,  8].Visible := b;
  aIm_barrels[1, 10].Visible := b;
  aIm_barrels[5, 10].Visible := b;
end;





procedure TForm1.Vid_Show_All_Flames(b: boolean);
{ displays/hides all flames                                                    }
  var
    i: integer;
begin
  for i := 1 to 7 do
    begin
      aIm_flames[i, 1].Visible := b;
      aIm_flames[i, 3].Visible := b;
      aIm_flames[i, 5].Visible := b;
      aIm_flames[i, 7].Visible := b;

      if i <> 4 then
        aIm_flames[i, 9].Visible := b;
    end;
end;





procedure TForm1.Vid_Show_All_Holes(b: boolean);
{ displays/hides all holes                                                     }
  var
    i: integer;
begin
  for i := 1 to 7 do
    if Odd(i) then
      aIm_holes[6, i].Visible := b;

  aIm_holes[4, 3].Visible := b;
  aIm_holes[4, 7].Visible := b;
end;





procedure TForm1.Vid_Show_All_Items(b: boolean);
{ displays/hides all bonus items                                               }
  var
    i: integer;
begin
  for i := 2 to 8 do
    if not Odd(i) then
      aIm_items[i].Visible := b;
end;





procedure TForm1.Vid_Show_All_Kong(b: boolean);
{ displays/hides all sprites of Donkey Kong                                    }
  var
    i: integer;
begin
  for i := 1 to 4 do
    aIm_kong[i].Visible := b;
end;





procedure TForm1.Vid_Show_All_Mario(b: boolean);
{ displays/hides all sprites of Mario                                          }
  var
    i, j: integer;
begin
  aIm_mario[5, 11].Visible := b;

  for i := 1 to 3 do
    aIm_mario[i, 10].Visible := b;

  for i := 5 to 7 do
    aIm_mario[i, 10].Visible := b;

  for i := 1 to 7 do
    for j := 1 to 9 do
      aIm_mario[i, j].Visible := b;
end;





procedure TForm1.Vid_Show_All_Rivets(b: boolean);
{ displays/hides all rivets                                                    }
  var
    i: integer;
begin
  for i := 1 to 9 do
    if Odd(i) then
      begin
        aIm_rivets[2, i].Visible := b;
        aIm_rivets[6, i].Visible := b;
      end;
end;





procedure TForm1.Vid_Show_All_Stairs(b: boolean);
{ displays/hides all stairs                                                    }
begin
  aIm_stairs[5,  2].Visible := b;
  aIm_stairs[3,  4].Visible := b;
  aIm_stairs[7,  4].Visible := b;
  aIm_stairs[1,  6].Visible := b;
  aIm_stairs[5,  6].Visible := b;
  aIm_stairs[3,  8].Visible := b;
  aIm_stairs[7,  8].Visible := b;
  aIm_stairs[1, 10].Visible := b;
  aIm_stairs[5, 10].Visible := b;
end;





procedure TForm1.Vid_Show_Panel_Lives(p: integer);
{ displays/hides remaining lives (0 to 2)                                      }
  var
    i: integer;
begin
  for i := 1 to 2 do
    aIm_panel_lives[i].Visible := p >= i;
end;





procedure TForm1.Vid_Show_Panel_Score(var p: integer);
{ displays score/hiscore/bonus panel                                           }
  var
    i: integer;
begin
  i := p;

  while i > 999 do
    Dec(i, 1000);

  if i > 99  then aIm_panel_digit_pos[1].Picture := aIm_panel_number[i div 100 mod 10].Picture else aIm_panel_digit_pos[1].Picture := aIm_panel_number[0].Picture; // X0000
  if i > 9   then aIm_panel_digit_pos[2].Picture := aIm_panel_number[i div  10 mod 10].Picture else aIm_panel_digit_pos[2].Picture := aIm_panel_number[0].Picture; // 0X000
  if i >= 0  then aIm_panel_digit_pos[3].Picture := aIm_panel_number[i         mod 10].Picture else aIm_panel_digit_pos[3].Picture := aIm_panel_number[0].Picture; // 00X00
                  aIm_panel_digit_pos[4].Picture := aIm_panel_number[0].Picture;                                                                                   // 000X0
                  aIm_panel_digit_pos[5].Picture := aIm_panel_number[0].Picture;                                                                                   // 0000X
end;





procedure TForm1.Vid_Show_Fireball(p: integer);
{ displays fireball. parameter is which fireball (1-3)                         }
begin
  if Odd(aFireballs[p].iPosY) then
    if not ((aFireballs[p].iPosX = 4) and (aFireballs[p].iPosY = 9)) then
      begin
        aIm_barrels[aFireballs[p].iPosX, aFireballs[p].iPosY].Visible := true;
        aIm_flames[aFireballs[p].iPosX, aFireballs[p].iPosY].Visible := true;
      end
    else
  else
    aIm_barrels[aFireballs[p].iPosX, aFireballs[p].iPosY].Visible := true;
end;





procedure TForm1.Vid_Show_Item(p: integer; b: boolean);
{ displays/hides item "p" position. b=visible/invisible                        }
begin
  aIm_items[p].Visible := b;
end;





procedure TForm1.Vid_Show_Mario(b: boolean);
{ displays/hides Mario. x,y coordinates must be set before calling function    }
begin
  aIm_mario[iMarioX, iMarioY].Visible := b;
end;





procedure TForm1.Vid_Show_Stairs(s0502, s0304, s0704, s0106, s0506, s0308, s0708, s0110, s0510: boolean);
{ displays/hides stairs in several combinations                                }
begin
  aIm_stairs[5,  2].Visible := s0502;
  aIm_stairs[3,  4].Visible := s0304;
  aIm_stairs[7,  4].Visible := s0704;
  aIm_stairs[1,  6].Visible := s0106;
  aIm_stairs[5,  6].Visible := s0506;
  aIm_stairs[3,  8].Visible := s0308;
  aIm_stairs[7,  8].Visible := s0708;
  aIm_stairs[1, 10].Visible := s0110;
  aIm_stairs[5, 10].Visible := s0510;
end;





procedure TForm1.Vid_Show_Woman(p: integer);
{ displays woman and "HELP" message in several combinations                    }
begin
  if p = 0 then
    begin
      im_woman_1.Visible := false;
      im_woman_2.Visible := false;
    end
  else
    if p = 1 then
      begin
        im_woman_1.Visible := true;
        im_woman_2.Visible := false;
      end
    else
      begin
        im_woman_1.Visible := true;
        im_woman_2.Visible := true;
      end;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: AUDIO MANAGEMENT                                             * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Snd_Play(pfs: PFSoundSample);
{ plays a certain sound sample                                                 }
begin
  if bSound then
    FSOUND_PlaySound(FSOUND_FREE, pfs);
end;





procedure TForm1.Snd_Silence;
{ stops any currently playing sound sample                                     }
begin
  if bSound then
    FSOUND_StopSound(FSOUND_ALL);
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - EVENTS                                    * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.im_backgroundMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: PRESS                                                }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (Button = mbLeft) then
    begin
      iMouseX := X;
      iMouseY := Y;
    end;
end;





procedure TForm1.im_backgroundMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{ dragging the main form: MOVE                                                 }
{ Note: this routine works if the game is not in 'Fullscreen' mode only        }
begin
{}if (not bFullscreenMode)
    and (ssLeft in Shift) then
    begin
      Top  := Top  + Y - iMouseY;
      Left := Left + X - iMouseX;
    end;
end;





procedure TForm1.btn_power_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ power button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_power_down;
end;





procedure TForm1.btn_jump_topMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ jump button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_jump_down;
end;





procedure TForm1.btn_jump_topMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ jump button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_jump_up;
end;





procedure TForm1.btn_ctrlr_overlay_upMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ up button: PRESS                                                             }
begin
  if Button = mbLeft then
    Inp_up_down;
end;





procedure TForm1.btn_ctrlr_overlay_upMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ up button: RELEASE                                                           }
begin
  if Button = mbLeft then
    Inp_up_up;
end;





procedure TForm1.btn_ctrlr_overlay_leftMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_left_down;
end;





procedure TForm1.btn_ctrlr_overlay_leftMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ left button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_left_up;
end;





procedure TForm1.btn_ctrlr_overlay_rightMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: PRESS                                                          }
begin
  if Button = mbLeft then
    Inp_right_down;
end;





procedure TForm1.btn_ctrlr_overlay_rightMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ right button: RELEASE                                                        }
begin
  if Button = mbLeft then
    Inp_right_up;
end;





procedure TForm1.btn_ctrlr_overlay_downMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ down button: PRESS                                                           }
begin
  if Button = mbLeft then
    Inp_down_down;
end;





procedure TForm1.btn_ctrlr_overlay_downMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ down button: RELEASE                                                         }
begin
  if Button = mbLeft then
    Inp_down_up;
end;





procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: PRESS                                                              }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[1].word then Inp_power_down  else                              // Power On/Off
  if Key = aKeys[2].word then Inp_up_down     else                              // Up
  if Key = aKeys[3].word then Inp_left_down   else                              // Left
  if Key = aKeys[4].word then Inp_right_down  else                              // Right
  if Key = aKeys[5].word then Inp_down_down   else                              // Down
  if Key = aKeys[6].word then Inp_jump_down;                                    // Jump
end;





procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
{ keypress: RELEASE                                                            }
begin
  // note: can't use the "case..of" construct on the aKeys[n].word
  if Key = aKeys[2].word then Inp_up_up     else                                // Up
  if Key = aKeys[3].word then Inp_left_up   else                                // Left
  if Key = aKeys[4].word then Inp_right_up  else                                // Right
  if Key = aKeys[5].word then Inp_down_up   else                                // Down
  if Key = aKeys[6].word then Inp_jump_up;                                      // Jump
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: INPUT MANAGEMENT - ACTIONS                                   * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Inp_power_down;
{ power switch: PRESS                                                          }
begin
  btn_power_down.Visible := not btn_power_down.Visible;

  Snd_Silence;                                                                  // stops playing sounds
  Snd_Play(pfs_power);                                                          // plays sound sample

  if iMode = 0 then                                                             // Power Off ->
    begin                                                                         //           -> Power On (demo mode)
      iMode := 1;
      btn_power_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_PWR_ON; // "click to turn off"
    end
  else                                                                          // whichever ->
    begin                                                                         //           -> Power Off
      iMode := 0;
      btn_power_top.Hint := HINT_CLICK + ' ' + aKeyHints[aKeys[1].int] + ' ' + HINT_PWR_OFF; // "click to turn on"
    end;

  Gam_Set_Mode;
end;





procedure TForm1.Inp_jump_down;
{ jump button: PRESS                                                           }
begin
  btn_jump_down.Visible := true;

  if not bKeyPressedJump then
    begin
      bKeyPressedJump := true;
      Snd_Play(pfs_button);

      if (iMode = 1)                                                            // demo mode ->
        or (iMode = 3) then                                                     // game over ->
        begin
          iMode := 2; Gam_Set_Mode;                                             //           -> game begins
        end
      else
        if (iMode = 2)                                                          // in-game   ->
          and bController                                                       //           -> Mario jumps
          and Odd(iMarioY)
          and (iNextMove <= 2) then
          begin
            Inc(iNextMove, 5);

            iLoopMarioMove := 1;
            Timer_Mario_Move.Interval := 100;
            Timer_Mario_Move.Enabled := true;
          end;
    end;
end;





procedure TForm1.Inp_jump_up;
{ jump button: RELEASE                                                         }
begin
  btn_jump_down.Visible := false;

  bKeyPressedJump := false;
end;





procedure TForm1.Inp_left_down;
{ left joystick: PRESS                                                         }
begin
  btn_joystick_bottom.Picture := btn_joystick_bottom_left.Picture;

  if not bKeyPressedLeft then
    begin
      bKeyPressedLeft  := true;
      bKeyPressedRight := false;
      bKeyPressedDown  := false;
      bKeyPressedUp    := false;

      if bController
        and Odd(iMarioY)
        and (iNextMove = 0) then
        begin
          iNextMove := 1;

          iLoopMarioMove := 1;
          Timer_Mario_Move.Interval := 100;
          Timer_Mario_Move.Enabled := true;
        end;
    end;
end;





procedure TForm1.Inp_left_up;
{ left joystick: RELEASE                                                       }
begin
  btn_joystick_bottom.Picture := nil;

  bKeyPressedLeft := false;
end;





procedure TForm1.Inp_right_down;
{ right joystick: PRESS                                                        }
begin
  btn_joystick_bottom.Picture := btn_joystick_bottom_right.Picture;

  if not bKeyPressedRight then
    begin
      bKeyPressedRight := true;
      bKeyPressedLeft  := false;
      bKeyPressedDown  := false;
      bKeyPressedUp    := false;

      if bController
        and Odd(iMarioY)
        and (iNextMove = 0) then
        begin
          iNextMove := 2;

          iLoopMarioMove := 1;
          Timer_Mario_Move.Interval := 100;
          Timer_Mario_Move.Enabled := true;
        end;
    end;
end;





procedure TForm1.Inp_right_up;
{ right joystick: RELEASE                                                      }
begin
  btn_joystick_bottom.Picture := nil;

  bKeyPressedRight := false;
end;





procedure TForm1.Inp_up_down;
{ up joystick: PRESS                                                           }
begin
  btn_joystick_bottom.Picture := btn_joystick_bottom_up.Picture;

  if not bKeyPressedDown then
    begin
      bKeyPressedUp   := true;
      bKeyPressedDown := false;

      if bController
        and ((Odd(iMarioY) and Gam_Check_Stair_Over_Mario) or not Odd(iMarioY))
        and (iNextMove = 0) then
        begin
          iNextMove := 4;

          iLoopMarioMove := 1;
          Timer_Mario_Move.Interval := 100;
          Timer_Mario_Move.Enabled := true;
        end;
    end;
end;





procedure TForm1.Inp_up_up;
{ up joystick: RELEASE                                                         }
begin
  btn_joystick_bottom.Picture := nil;

  bKeyPressedUp := false;
end;





procedure TForm1.Inp_down_down;
{ down joystick: PRESS                                                         }
begin
  btn_joystick_bottom.Picture := btn_joystick_bottom_down.Picture;

  if not bKeyPressedDown then
    begin
      bKeyPressedDown := true;
      bKeyPressedUp   := false;

      if bController
        and ((Odd(iMarioY) and Gam_Check_Stair_Under_Mario) or not Odd(iMarioY))
        and (iNextMove = 0) then
        begin
          iNextMove := 3;

          iLoopMarioMove := 1;
          Timer_Mario_Move.Interval := 100;
          Timer_Mario_Move.Enabled := true;
        end;
    end;
end;





procedure TForm1.Inp_down_up;
{ down joystick: RELEASE                                                       }
begin
  btn_joystick_bottom.Picture := nil;

  bKeyPressedDown := false;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME ROUTINES                                                * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Gam_Stop_All_Timers;
{ stops action                                                                 }
begin
  Timer_Game_1.Enabled         := false;
  Timer_Game_2.Enabled         := false;
  Timer_Game_3.Enabled         := false;
  Timer_Game_Start.Enabled     := false;
  Timer_Mario_Move.Enabled     := false;
  Timer_Miss.Enabled           := false;
  Timer_Stage_Complete.Enabled := false;
  Timer_Time_Counter.Enabled   := false;
  Timer_Woman_Blink.Enabled    := false;
end;





procedure TForm1.Gam_Do_Miss;
{ a miss has occured. goes into "miss" routine                                 }
begin
  Gam_Stop_All_Timers;

  Snd_Silence;
  Snd_Play(pfs_miss);

  bController := false;

  iLoopMiss := 1;
  Timer_Miss.Interval := 3650;
  Timer_Miss.Enabled := true;
end;





procedure TForm1.Gam_Change_Stage;
{ awards bonus score then proceeds to next stage. loops stages between 1-16    }
begin
  Gam_Stop_All_Timers;

  bController := false;

  Snd_Silence;
  Snd_Play(pfs_complete);

  // increases score by current bonus score
  Inc(iScore, iBonusScore);
  Vid_Show_Panel_Score(iBonusScore);
  im_panel_bonus.Visible := true;

  // number of stage increases
  Inc(iCurrentStage);

  // sets bonus score for next level (increases by 10 points at every 2 stages, max=80)
  iBonusScore := ((iCurrentStage + 1) div 2) * 10;

  if iBonusScore > 80 then
    iBonusScore := 80;

  // executes timer then proceeds to next stage
  iLoopStageComplete := 1;
  Timer_Stage_Complete.Interval := 3700;
  Timer_Stage_Complete.Enabled := true;
end;





procedure TForm1.Gam_Init_Stage;
{ inits variable at the beginning of each stage. function is called both when  }
{ a new stage begins, and after a life is lost                                 }
  var i: integer;
begin
  // specific settings for odd and even stages
  if Odd(iCurrentStage) then
    begin                                                                       // odd stages (barrels game)
      // displays hammer only
      Vid_Show_All_Items(false);
      Vid_Show_Item(6, true);

      // displays stairs layout (loops at every 15 stages)
      i := iCurrentStage;

      while i > 16 do                                                             // loops 16 levels
        Dec(i, 16);

      case i of
        1: Vid_Show_Stairs(true, true,  true, true, true,  false, true, true, true); // 1-1
        3: Vid_Show_Stairs(true, true,  true, true, false, false, true, true, true); // 2-1
        5: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 3-1
        7: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 4-1
        9: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 5-1
       11: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 6-1
       13: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 7-1
       15: Vid_Show_Stairs(true, false, true, true, false, false, true, true, true); // 8-1
      end; // case..of

      // hides barrels and flames. displays Mario in (2,1)
      Vid_Show_All_Barrels(false);
      Vid_Show_All_Flames(false);

      Vid_Show_All_Mario(false);
      iMarioX := 2;
      iMarioY := 1;
      Vid_Show_Mario(true);

      // action starts here!
      iLoopGame1 := 1;
      Timer_Game_1.Interval := 340;
      Timer_Game_1.Enabled := true;
    end
  else
    begin                                                                       // even stages (rivets game)
      // displays all bonus items
      Vid_Show_All_Items(true);

      // displays stairs layout
      Vid_Show_Stairs(true, true, true, true, true, true, true, true, true);

      // hides barrels and flames. displays Mario in (3,1)
      Vid_Show_All_Barrels(false);
      Vid_Show_All_Flames(false);

      Vid_Show_All_Mario(false);
      iMarioX := 3;
      iMarioY := 1;
      Vid_Show_Mario(true);

      // sets variables
      iRivetsLeft := 10;

      with aFireballs[1] do begin iPosX := 2; iPosY := 3; end; Vid_Show_Fireball(1);
      with aFireballs[2] do begin iPosX := 6; iPosY := 7; end; Vid_Show_Fireball(2);
      with aFireballs[3] do begin iPosX := 7; iPosY := 8; end; Vid_Show_Fireball(3);

      // action starts here!
      Timer_Game_2.Interval := 580;
      Timer_Game_2.Enabled := true;

      iLoopGame3 := 1;
      Timer_Game_3.Interval := 310;
      Timer_Game_3.Enabled := true;
    end;

  // common settings to all stages
  Gam_Set_MoveCells;
  
  Vid_Show_All_Holes(true);
  Vid_Show_All_Rivets(true);
  Vid_Show_Panel_Lives(iLives);
  Vid_Show_Panel_Score(iScore);
  Vid_Show_Woman(1);

  iLoopKong := 1;
  aIm_kong[2].Visible := true;
  aIm_kong[3].Visible := false;
  aIm_kong[4].Visible := false;

  bKeyPressedLeft  := false;
  bKeyPressedRight := false;
  bKeyPressedDown  := false;
  bKeyPressedUp    := false;

  iNextMove := 0;
  bController := true;

  // action starts here!
  iLoopWomanBlink := 30;                                                        // "Help" first appears 3 seconds after game starts
  Timer_Woman_Blink.Interval := 100;
  Timer_Woman_Blink.Enabled := true;

  iLoopTimeCounter := 1;
  Timer_Time_Counter.Interval := 100;
  Timer_Time_Counter.Enabled := true;
end;





procedure TForm1.Gam_Mario_Jumps_Left;
{ Mario jumps left. checks for items, barrels, or misses                       }
  var
    bItem,
    bBarrel,
    bMiss:   boolean;
begin
  if Odd(iMarioY) then
    begin
      bMiss := false;

      // jump is not allowed through the electric fence or off the girders
      if ((iMarioX = 5) and (iMarioY = 9))
        or ((iMarioX = 4) and (iMarioY = 9))
        or (iMarioX = 1) then
        bMiss := true;

      if bMiss then                                                             // has a miss occured?
        begin                                                                     // yes -> miss routine
          if iMarioX = 1 then
            Vid_Show_Mario(false);

          Gam_Do_Miss;
        end
      else                                                                      // or
        begin                                                                     // no, Mario jumps
          // displays Mario jumping
          Vid_Show_Mario(false);
          Dec(iMarioX);
          Inc(iMarioY);
          Vid_Show_Mario(true);

          // checks for collision with bonus items
          bItem := false;

          if (iMarioX = 4) and aIm_items[iMarioY].Visible then
            begin
              aIm_items[iMarioY].Visible := false;
              bItem := true;
            end;

          // checks for barrels on the left side of Mario
          bBarrel := false;

          if aIm_barrels[iMarioX + 1, iMarioY - 1].Visible then
            bBarrel := true;

          // score management
          if bItem then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          if bBarrel then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          // plays sound sample
          if bItem or bBarrel then
            Snd_Play(pfs_bonus)
          else
            Snd_Play(pfs_jump);

          // further checks (goes into case 3 in Timer_Mario_MoveTimer)
          iLoopMarioMove := 3;
        end;
    end;
end;





procedure TForm1.Gam_Mario_Jumps_Right;
{ Mario jumps right. checks for items, barrels, or misses                      }
  var
    bItem,
    bBarrel,
    bMiss:   boolean;
begin
  if Odd(iMarioY) then
    begin
      bMiss := false;

      // jump is not allowed through the electric fence or off the girders
      if ((iMarioX = 3) and (iMarioY = 9))
        or ((iMarioX = 4) and (iMarioY = 9))
        or (iMarioX = 7) then
        bMiss := true;

      if bMiss then                                                             // has a miss occured?
        begin                                                                     // yes -> miss routine
          if iMarioX = 7 then
            Vid_Show_Mario(false);

          Gam_Do_Miss;
        end
      else                                                                      // or
        begin                                                                     // no, Mario jumps
          // displays Mario jumping
          Vid_Show_Mario(false);
          Inc(iMarioX);
          Inc(iMarioY);
          Vid_Show_Mario(true);

          // checks for collision with bonus items
          bItem := false;

          if (iMarioX = 4) and aIm_items[iMarioY].Visible then
            begin
              aIm_items[iMarioY].Visible := false;
              bItem := true;
            end;

          // checks for barrels on the left side of Mario
          bBarrel := false;

          if aIm_barrels[iMarioX, iMarioY - 1].Visible then
            bBarrel := true;

          // score management
          if bItem then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          if bBarrel then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          // plays sound sample
          if bItem or bBarrel then
            Snd_Play(pfs_bonus)
          else
            Snd_Play(pfs_jump);

          // further checks (goes into case 3 in Timer_Mario_MoveTimer)
          iLoopMarioMove := 3;
        end;
    end;
end;





procedure TForm1.Gam_Mario_Jumps_Up;
{ Mario jumps up. checks for items, barrels, or misses                         }
  var
    bItem,
    bBarrel,
    bMiss:   boolean;
begin
  if Odd(iMarioY) then
    begin
      bMiss := false;

      // jump is not allowed through the electric fence
      if (iMarioX = 4) and (iMarioY = 9) then
        bMiss := true;

      if bMiss then                                                             // has a miss occured?
        Gam_Do_Miss                                                               // yes -> miss routine
      else                                                                      // or
        begin                                                                     // no, Mario jumps
          // displays Mario jumping
          Vid_Show_Mario(false);
          Inc(iMarioY);
          Vid_Show_Mario(true);

          // checks for collision with bonus items
          bItem := false;

          if (iMarioX = 4) and aIm_items[iMarioY].Visible then
            begin
              aIm_items[iMarioY].Visible := false;
              bItem := true;
            end;

          // checks for barrels on the left or right side of Mario (except 4,9)
          bBarrel := false;

          if ((iMarioX = 3) and (iMarioY = 10))                                 // in cell (3,9), check on the left side of Mario only
            or (iMarioX = 7) then                                               // in column 7,   check on the left side of Mario only
            if aIm_barrels[iMarioX, iMarioY - 1].Visible then
              bBarrel := true
            else
          else
            if aIm_barrels[iMarioX, iMarioY - 1].Visible                        // in any other case, check both on the left and right sides of Mario
              or aIm_barrels[iMarioX + 1, iMarioY - 1].Visible then
              bBarrel := true;

          // score management
          if bItem then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          if bBarrel then
            begin
              Inc(iScore, 2);
              Vid_Show_Panel_Score(iScore);
            end;

          // plays sound sample
          if bItem or bBarrel then
            Snd_Play(pfs_bonus)
          else
            Snd_Play(pfs_jump);

          // further checks (goes into case 3 in Timer_Mario_MoveTimer)
          iLoopMarioMove := 3;
        end;
    end;
end;





procedure TForm1.Gam_Mario_Moved;
{ Mario moved. He keeps on moving if any key is being pressed                  }
begin
  if bKeyPressedLeft then
    begin                                                                       // move left
      iNextMove := 1;

      iLoopMarioMove := 1;
      Timer_Mario_Move.Interval := 100;
      Timer_Mario_Move.Enabled := true;
    end
  else
    if bKeyPressedRight then
      begin                                                                       // move right
        iNextMove := 2;

        iLoopMarioMove := 1;
        Timer_Mario_Move.Interval := 100;
        Timer_Mario_Move.Enabled := true;
      end
    else
      if bKeyPressedDown then
        begin                                                                       // move down
          iNextMove := 3;

          iLoopMarioMove := 1;
          Timer_Mario_Move.Interval := 100;
          Timer_Mario_Move.Enabled := true;
        end
      else
        if bKeyPressedUp then
          begin                                                                       // move up
            iNextMove := 4;

            iLoopMarioMove := 1;
            Timer_Mario_Move.Interval := 100;
            Timer_Mario_Move.Enabled := true;
          end
        else
          begin                                                                         // no move
            iNextMove := 0;

            Timer_Mario_Move.Enabled := false;
          end;
end;





procedure TForm1.Gam_Set_Mode;
{ sets off/on/game/over mode, depending on the value of the iMode variable     }
  var
    i: integer;
begin
  case iMode of
    0: begin                                                                    // tabletop is off
         Gam_Stop_All_Timers;                                                     // stops all timers
         bController := false;                                                    // disables controller

         im_background_screen_on.Visible := false;                                // turns off display
         Vid_Show_All_Barrels(false);                                             // as above
         Vid_Show_All_Flames(false);                                              // as above
         Vid_Show_All_Holes(false);                                               // as above
         Vid_Show_All_Items(false);                                               // as above
         Vid_Show_All_Kong(false);                                                // as above
         Vid_Show_All_Mario(false);                                               // as above
         Vid_Show_All_Rivets(false);                                              // as above
         Vid_Show_All_Stairs(false);                                              // as above
         Vid_Show_Panel_Lives(0);                                                 // as above
         Vid_Show_Woman(0);                                                       // as above
         im_panel_bonus.Visible := false;                                         // as above
         im_panel_hiscore.Visible := false;                                       // as above

         for i := 1 to 5 do                                                       // as above
           aIm_panel_digit_pos[i].Visible := false;
       end;
    1: begin                                                                    // tabletop is on (demo mode)
         im_background_screen_on.Visible := true;                                 // displays items for "demo" mode
         aIm_stairs[1,  6].Visible := true;                                       // as above
         aIm_stairs[1, 10].Visible := true;                                       // as above
         aIm_stairs[5, 10].Visible := true;                                       // as above
         aIm_stairs[7,  4].Visible := true;                                       // as above
         aIm_stairs[7,  8].Visible := true;                                       // as above
         aIm_holes[4, 7].Visible := true;                                         // as above
         aIm_holes[6, 3].Visible := true;                                         // as above
         aIm_kong[1].Visible := true;                                             // as above
         aIm_kong[2].Visible := true;                                             // as above
         Vid_Show_Woman(2);                                                       // as above
         aIm_items[8].Visible := true;                                            // as above
         iScore := 0; Vid_Show_Panel_Score(iScore);                               // as above

         for i := 1 to 5 do                                                       // as above
           aIm_panel_digit_pos[i].Visible := true;
       end;
    2: begin                                                                    // game
         iLives := 2;
         iScore := 0;
         iBonusScore := 10;
         iCurrentStage := 1;

         Snd_Play(pfs_start1);

         Timer_Game_Start.Interval := 3500;
         Timer_Game_Start.Enabled := true;
       end;
    3: begin                                                                    // game over (do nothing)
       end;
  end; // case..of
end;





procedure TForm1.Gam_Set_MoveCells;
{ sets paths over cells                                                        }
begin
  aMoveCells[1, 10] := 4;                                                                        aMoveCells[5, 10] := 4;
  aMoveCells[1,  9] := 10; aMoveCells[2, 9] := 3; aMoveCells[3, 9] := 7;  aMoveCells[4, 9] := 3; aMoveCells[5,  9] := 11; aMoveCells[6, 9] := 3; aMoveCells[7, 9] := 5;
                                                  aMoveCells[3, 8] := 12;                                                                        aMoveCells[7, 8] := 12;
  aMoveCells[1,  7] := 6;  aMoveCells[2, 7] := 3; aMoveCells[3, 7] := 11; aMoveCells[4, 7] := 3; aMoveCells[5,  7] := 7;  aMoveCells[6, 7] := 3; aMoveCells[7, 7] := 9;
  aMoveCells[1,  6] := 12;                                                                       aMoveCells[5,  6] := 12;
  aMoveCells[1,  5] := 10; aMoveCells[2, 5] := 3; aMoveCells[3, 5] := 7;  aMoveCells[4, 5] := 3; aMoveCells[5,  5] := 11; aMoveCells[6, 5] := 3; aMoveCells[7, 5] := 5;
                                                  aMoveCells[3, 4] := 12;                                                                        aMoveCells[7, 4] := 12;
  aMoveCells[1,  3] := 6;  aMoveCells[2, 3] := 3; aMoveCells[3, 3] := 11; aMoveCells[4, 3] := 3; aMoveCells[5,  3] := 7;  aMoveCells[6, 3] := 3; aMoveCells[7, 3] := 9;
  aMoveCells[1,  2] := 12;                                                                       aMoveCells[5,  2] := 12;
  aMoveCells[1,  1] := 10; aMoveCells[2, 1] := 3; aMoveCells[3, 1] := 3;  aMoveCells[4, 1] := 3; aMoveCells[5,  1] := 11; aMoveCells[6, 1] := 3; aMoveCells[7, 1] := 1;
end;





function TForm1.Gam_Check_Stair_Over_Mario: boolean;
{ returns TRUE if there's a stair over Mario's head                            }
begin
  if ((iMarioX = 5) and (iMarioY = 1)) and aIm_stairs[5,  2].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 3) and (iMarioY = 3)) and aIm_stairs[3,  4].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 7) and (iMarioY = 3)) and aIm_stairs[7,  4].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 1) and (iMarioY = 5)) and aIm_stairs[1,  6].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 5) and (iMarioY = 5)) and aIm_stairs[5,  6].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 3) and (iMarioY = 7)) and aIm_stairs[3,  8].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 7) and (iMarioY = 7)) and aIm_stairs[7,  8].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 1) and (iMarioY = 9)) and aIm_stairs[1, 10].Visible then Gam_Check_Stair_Over_Mario := true else
  if ((iMarioX = 5) and (iMarioY = 9)) and aIm_stairs[5, 10].Visible then Gam_Check_Stair_Over_Mario := true else
  Gam_Check_Stair_Over_Mario := false;
end;





function TForm1.Gam_Check_Stair_Under_Mario: boolean;
{ returns TRUE if there's a stair under Mario's feet                           }
begin
  if ((iMarioX = 5) and (iMarioY = 3)) and aIm_stairs[5, 2].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 3) and (iMarioY = 5)) and aIm_stairs[3, 4].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 7) and (iMarioY = 5)) and aIm_stairs[7, 4].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 1) and (iMarioY = 7)) and aIm_stairs[1, 6].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 5) and (iMarioY = 7)) and aIm_stairs[5, 6].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 3) and (iMarioY = 9)) and aIm_stairs[3, 8].Visible then Gam_Check_Stair_Under_Mario := true else
  if ((iMarioX = 7) and (iMarioY = 9)) and aIm_stairs[7, 8].Visible then Gam_Check_Stair_Under_Mario := true else
  Gam_Check_Stair_Under_Mario := false;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: TIMERS                                                       * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.Timer_Game_1Timer(Sender: TObject);
{ main loop for odd levels (barrels game)                                      }
  var
    i:     integer;
    bMiss: boolean;
begin
  // miss check
  bMiss := false;

  if (iMarioY = 1) or (iMarioY = 5) or ((iMarioY = 9) and (iMarioX > 4)) then   // rows 1, 5 and 9
    if aIm_barrels[iMarioX, iMarioY].Visible then
      bMiss := true;

  if (iMarioY = 3) or (iMarioY = 7) then                                        // rows 3 and 7
    if ((iMarioX < 7) and (aIm_barrels[iMarioX + 1, iMarioY].Visible)) or ((iMarioX = 7) and (aIm_barrels[iMarioX, iMarioY].Visible)) then
      bMiss := true;

  if ((iMarioY = 1) or (iMarioY = 2) or (iMarioY = 5) or (iMarioY = 6)) and ((iMarioX = 1) or (iMarioX = 5)) then // stairs on rows 1 and 5
    if aIm_barrels[iMarioX, iMarioY + 1].Visible then
      bMiss := true;

  if ((iMarioY = 3) or (iMarioY = 4) or (iMarioY = 7) or (iMarioY = 8)) and (iMarioX = 7) then // stairs on rows 3 and 7
    if aIm_barrels[iMarioX, iMarioY + 1].Visible then
      bMiss := true;

  if (iMarioY = 4) and (iMarioX = 3) then                                       // stairs on rows 3 and 7
    if aIm_barrels[iMarioX, iMarioY + 1].Visible then
      bMiss := true;

  // a miss has occured, or barrels movement
  if bMiss then
    Gam_Do_Miss                                                                 // a miss has occured
  else
    begin                                                                       // no miss -> barrels move
      // row 1
      for i := 7 downto 2 do
        aIm_barrels[i, 1].Visible := aIm_barrels[i - 1, 1].Visible;

      aIm_barrels[1, 1].Visible := false;

      // stairs from row 3 to row 1
      aIm_barrels[1, 1].Visible := aIm_barrels[1, 2].Visible;
      aIm_barrels[1, 2].Visible := aIm_barrels[1, 3].Visible;
      aIm_barrels[1, 3].Visible := false;
      aIm_barrels[5, 1].Visible := aIm_barrels[5, 2].Visible or aIm_barrels[5, 1].Visible;

      if aIm_barrels[5, 3].Visible then
        begin
          if random(3) = 0 then
            begin
              aIm_barrels[5, 2].Visible := true;
              aIm_barrels[5, 3].Visible := false;
            end;
        end
      else
        aIm_barrels[5, 2].Visible := false;

      // row 3
      for i := 1 to 6 do
        aIm_barrels[i, 3].Visible := aIm_barrels[i + 1, 3].Visible;

      // stairs from row 5 to row 3
      aIm_barrels[3, 3].Visible := aIm_barrels[3, 4].Visible or aIm_barrels[3, 3].Visible;

      if aIm_barrels[3, 5].Visible then
        begin
          if random(3) = 0 then
            begin
              aIm_barrels[3, 4].Visible := true;
              aIm_barrels[3, 5].Visible := false;
            end;
        end
      else
        aIm_barrels[3, 4].Visible := false;

      aIm_barrels[7, 3].Visible := aIm_barrels[7, 4].Visible;
      aIm_barrels[7, 4].Visible := aIm_barrels[7, 5].Visible;
      aIm_barrels[7, 5].Visible := false;

      // row 5
      for i := 7 downto 2 do
        aIm_barrels[i, 5].Visible := aIm_barrels[i - 1, 5].Visible;

      aIm_barrels[1, 5].Visible := false;

      // stairs from row 7 to row 5
      aIm_barrels[1, 5].Visible := aIm_barrels[1, 6].Visible;
      aIm_barrels[1, 6].Visible := aIm_barrels[1, 7].Visible;
      aIm_barrels[1, 7].Visible := false;
      aIm_barrels[5, 5].Visible := aIm_barrels[5, 6].Visible or aIm_barrels[5, 5].Visible;

      if aIm_barrels[5, 7].Visible then
        begin
          if random(3) = 0 then
            begin
              aIm_barrels[5, 6].Visible := true;
              aIm_barrels[5, 7].Visible := false;
            end;
        end
      else
        aIm_barrels[5, 6].Visible := false;

      // row 7
      for i := 1 to 6 do
        aIm_barrels[i, 7].Visible := aIm_barrels[i + 1, 7].Visible;

      // stairs from row 9 to row 7
      aIm_barrels[7, 7].Visible := aIm_barrels[7, 8].Visible;
      aIm_barrels[7, 8].Visible := aIm_barrels[7, 9].Visible;
      aIm_barrels[7, 9].Visible := false;

      // row 9
      for i := 7 downto 6 do
        aIm_barrels[i, 9].Visible := aIm_barrels[i - 1, 9].Visible;

      // stairs from row 11 to row 7
      aIm_barrels[5,  9].Visible := aIm_barrels[5, 10].Visible;
      aIm_barrels[5, 10].Visible := aIm_kong[4].Visible;
      aIm_kong[4].Visible := false;

      // generates barrel as Donkey Kong moves
      case iLoopGame1 of
        1: begin                                                                // case 1: Donkey Kong lifts arms
             aIm_kong[2].Visible := false;
             aIm_kong[3].Visible := true;

             // Donkey Kong generates barrel 2 times out of 3
             aIm_kong[4].Visible := iLoopKong <> 3;

             Inc(iLoopKong);

             if iLoopKong = 4 then
               iLoopKong := 1;
           end;
        2: begin                                                                // case 2: Donkey Kong lowers arms
             aIm_kong[3].Visible := false;
             aIm_kong[2].Visible := true;
           end;
      end; // case..of

       // loops action
       Inc(iLoopGame1);
       
       if iLoopGame1 = 7 then
         iLoopGame1 := 1;
      end
end;





procedure TForm1.Timer_Game_2Timer(Sender: TObject);
{ main loop for even levels (rivets game)                                      }
  var
    i:        integer;                                                          // fireball (1-3)
    aMoveDir: array[1..3] of integer;                                           // temp. directions for fireballs
    bMiss:    boolean;
begin
  // clears display
  Vid_Show_All_Barrels(false);
  Vid_Show_All_Flames(false);

  // sets direction for fireballs
  for i := 1 to 3 do
    begin
      aMoveDir[i] := 0;

      case aMoveCells[aFireballs[i].iPosX, aFireballs[i].iPosY] of
        1: aMoveDir[i] := 1;
        2: aMoveDir[i] := 2;
        3: aMoveDir[i] := 1 + Random(2);     // 1 or 2
        4: aMoveDir[i] := 4;
        5: aMoveDir[i] := 1 + Random(2) * 3; // 1 or 4
        6: aMoveDir[i] := 2 + Random(2) * 2; // 2 or 4
        7: case Random(3) of
             0: aMoveDir[i] := 1;
             1: aMoveDir[i] := 2;
             2: aMoveDir[i] := 4;
           end; // case..of
        8: aMoveDir[i] := 8;
        9: aMoveDir[i] := 1 + Random(2) * 7; // 1 or 8
       10: aMoveDir[i] := 2 + Random(2) * 6; // 2 or 8
       11: case Random(3) of
             0: aMoveDir[i] := 1;
             1: aMoveDir[i] := 2;
             2: aMoveDir[i] := 8;
           end;
       12: aMoveDir[i] := 4 + Random(2) * 4; // 4 or 8
      end; // case..of
    end;

  // miss check
  bMiss := false;

  for i := 1 to 3 do
    case aMoveDir[i] of
      1: if (aFireballs[i].iPosX - 1 = iMarioX) and (aFireballs[i].iPosY     = iMarioY) then bMiss := true; // left
      2: if (aFireballs[i].iPosX     = iMarioX) and (aFireballs[i].iPosY     = iMarioY) then bMiss := true; // right
      4: if (aFireballs[i].iPosX     = iMarioX) and (aFireballs[i].iPosY - 1 = iMarioY) then bMiss := true; // down
      8: if (aFireballs[i].iPosX     = iMarioX) and (aFireballs[i].iPosY + 1 = iMarioY) then bMiss := true; // up
    end; // case..of

  // moves fireballs
  if bMiss then
    Gam_Do_Miss
  else
    for i:=1 to 3 do
      case aMoveDir[i] of
        1: Dec(aFireballs[i].iPosX); // left
        2: Inc(aFireballs[i].iPosX); // right
        4: Dec(aFireballs[i].iPosY); // down
        8: Inc(aFireballs[i].iPosY); // up
      end; // case..of

  // displays fireballs
  for i := 1 to 3 do
    Vid_Show_Fireball(i);
end;





procedure TForm1.Timer_Game_3Timer(Sender: TObject);
{ Donkey Kong animation, used in even levels (rivets game) only                }
begin
  case iLoopGame3 of
    1: begin aIm_kong[2].Visible := false; aIm_kong[3].Visible := true; end;
    2: begin aIm_kong[3].Visible := false; aIm_kong[2].Visible := true; end;
  end;

  // loops action
  Inc(iLoopGame3);

  if iLoopGame3 = 7 then
    iLoopGame3 := 1;
end;





procedure TForm1.Timer_Game_StartTimer(Sender: TObject);
{ initializes a new stage and game action begins                               }
begin
  Gam_Init_Stage;

  Timer_Game_Start.Enabled := false;
end;





procedure TForm1.Timer_MissTimer(Sender: TObject);
{ a miss has occured! game continues or is over                                }
begin
  case iLoopMiss of
    1: begin
         Dec(iLives);

         if iLives < 0 then                                                     // no more lives?
           Timer_Miss.Interval := 1000                                            // game over with next timer tick
         else                                                                   // or
           begin                                                                  // game continues
             Gam_Init_Stage;

             Timer_Miss.Enabled := false;
           end;
       end;
    2: begin                                                                    // game over (pt 1)
         if iScore >= 1000 then
           iScore := 998;

         if iScore > iHiScore then
           begin
             iHiScore := iScore;
             iReg.WriteInteger('', 'HiScore1', iHiScore);
           end;

         im_panel_hiscore.Visible := true;
         Vid_Show_Panel_Score(iHiScore);
         Snd_Play(pfs_gameover);

         Timer_Miss.Interval := 3600;
       end;
    3: begin                                                                    // game over (pt 2)
         im_panel_hiscore.Visible := false;

         Vid_Show_Panel_Score(iScore);
         Vid_Show_All_Mario(false);
         Vid_Show_All_Barrels(false);
         Vid_Show_All_Flames(false);

         Vid_Show_Woman(2);

         aIm_kong[1].Visible := true;
         aIm_kong[2].Visible := true;
         aIm_kong[3].Visible := false;
         aIm_kong[4].Visible := false;

         iMode := 3; Gam_Set_Mode;
       end;
  end; // case..of

  Inc(iLoopMiss);
end;





procedure TForm1.Timer_Mario_MoveTimer(Sender: TObject);
{ Mario moves                                                                  }
  var
    bMiss: boolean;
begin
  bMiss := false;

  case iLoopMarioMove of
    1: begin                                                                    // phase 1
         case iNextMove of
           1: begin                                                               // move left
                Inc(iLoopMarioMove);

                if Odd(iMarioY) then
                  begin
                    if iMarioX > 1 then
                      begin
                        // checks for misses due to barrels
                        if (iMarioX <> 3) and (iMarioY <> 9) then
                          if aIm_barrels[iMarioX, iMarioY].Visible then
                            bMiss := true;

                        // checks for misses due to missing rivets
                        if ((iMarioX = 2) or (iMarioX = 6))
                          and (not aIm_rivets[iMarioX, iMarioY].Visible) then
                            bMiss := true;

                        if not bMiss then                                           // no miss occured
                          if ((not Odd(iCurrentStage))                                // even stages (rivets game)
                            and ((iMarioX = 2) or (iMarioX = 6)))                       // rivet under mario
                            and aIm_rivets[iMarioX, iMarioY].Visible then
                            begin
                              // Mario moves
                              Vid_Show_Mario(false);
                              Dec(iMarioX);
                              Vid_Show_Mario(true);

                              Snd_Play(pfs_step2);

                              // deletes rivet and updates the "aMoveCells" array
                              aIm_rivets[iMarioX + 1,iMarioY].Visible := false;

                              Dec(aMoveCells[iMarioX,     iMarioY], 2);
                              Dec(aMoveCells[iMarioX + 1, iMarioY]);
                              Dec(iRivetsLeft);

                              Inc(iScore, 2); Vid_Show_Panel_Score(iScore);

                              // last rivet check
                              if iRivetsLeft = 0 then
                                begin
                                  Vid_Show_Mario(false);
                                  aIm_mario[5, 11].Visible := true;

                                  Gam_Change_Stage;
                                end
                            end
                          else                                                      // odd stages (barrels game)
                            begin
                              // Mario moves
                              Vid_Show_Mario(false);
                              Dec(iMarioX);
                              Vid_Show_Mario(True);

                              Snd_Play(pfs_step1);
                            end;
                      end
                    else // (if iMarioX > 1)
                      begin
                        // Mario goes off girder
                        Vid_Show_Mario(false);
                        bMiss := true;
                      end;
                  end;
              end;
           2: begin                                                               // move right
                Inc(iLoopMarioMove);

                if Odd(iMarioY) then
                  begin
                    if iMarioX < 7 then
                      begin
                        // checks for misses due to barrels
                        if (iMarioX <> 5) and (iMarioY <> 9) then
                          if aIm_barrels[iMarioX + 1, iMarioY].Visible then
                            bMiss := true;

                        // checks for misses due to missing rivets
                        if ((iMarioX = 1) or (iMarioX = 5))
                          and (not aIm_rivets[iMarioX + 1, iMarioY].Visible) then
                            bMiss := true;

                        if not bMiss then                                           // no miss occured
                          if ((not Odd(iCurrentStage))                                // even stages (rivets game)
                            and ((iMarioX = 1) or (iMarioX = 5)))                     // rivet under mario
                            and aIm_rivets[iMarioX + 1, iMarioY].Visible then
                            begin
                              // Mario moves
                              Vid_Show_Mario(false);
                              Inc(iMarioX);
                              Vid_Show_Mario(true);

                              Snd_Play(pfs_step2);

                              // deletes rivet and updates the "aMoveCells" array
                              aIm_rivets[iMarioX, iMarioY].Visible := false;

                              Dec(aMoveCells[iMarioX,     iMarioY]);
                              Dec(aMoveCells[iMarioX - 1, iMarioY], 2);
                              Dec(iRivetsLeft);

                              Inc(iScore, 2); Vid_Show_Panel_Score(iScore);

                              // last rivet check
                              if iRivetsLeft = 0 then
                                begin
                                  Vid_Show_Mario(false);
                                  aIm_mario[5, 11].Visible := true;

                                  Gam_Change_Stage;
                                end
                            end
                          else
                            begin
                              // Mario moves
                              Vid_Show_Mario(false);
                              Inc(iMarioX);
                              Vid_Show_Mario(True);

                              Snd_Play(pfs_step1);
                            end;
                      end
                    else // (if iMarioX < 7)
                      begin
                        // Mario goes off girder
                        Vid_Show_Mario(false);
                        bMiss := true;
                      end;
                  end;
              end;
           3: begin                                                               // move down
                Inc(iLoopMarioMove);

                if Odd(iMarioY) then                                                // Mario is on a girder
                  if Gam_Check_Stair_Under_Mario then                                 // there's a stair under his feet
                    if aIm_barrels[iMarioX, iMarioY - 1].Visible then                   // there's a barrel on the stair
                      bMiss := true
                    else
                      begin
                        // Mario moves
                        Vid_Show_Mario(false);
                        Dec(iMarioY);
                        Vid_Show_Mario(true);

                        Snd_Play(pfs_step1);
                      end
                  else
                    iNextMove := 0
                else                                                                // Mario is on a stair
                  if aIm_barrels[iMarioX, iMarioY - 1].Visible then                   // there's a barrel on the stair
                    bMiss := true
                  else
                    begin
                      // Mario moves
                      Vid_Show_Mario(false);
                      Dec(iMarioY);
                      Vid_Show_Mario(true);

                      Snd_Play(pfs_step1);

                      iNextMove := 0;
                    end;
              end;
           4: begin                                                               // move up
                Inc(iLoopMarioMove);

                if Odd(iMarioY) then                                                // Mario is on a girder
                  if Gam_Check_Stair_Over_Mario then                                  // there's a stair over his head
                    if aIm_barrels[iMarioX, iMarioY + 1].Visible then                   // there's a barrel on the stair
                      bMiss := true
                    else
                      begin
                        // Mario moves
                        Vid_Show_Mario(false);
                        Inc(iMarioY);
                        Vid_Show_Mario(true);

                        Snd_Play(pfs_step1);
                      end
                  else
                    iNextMove := 0
                else                                                                // Mario is on a stair
                  if iMarioY = 10 then                                                // Mario is on the top stair
                    if Odd(iCurrentStage) and (iMarioX = 5) then                        // current level is "barrels game" and Mario is on the right stair
                      begin
                        // Mario moves + stage complete!
                        Vid_Show_Mario(false);
                        Inc(iMarioY);
                        Vid_Show_Mario(true);

                        Gam_Change_Stage;
                      end
                    else
                  else
                    if aIm_barrels[iMarioX, iMarioY + 1].Visible then                   // there's a barrel on the stair
                      bMiss := true
                    else
                      begin
                        // Mario moves
                        Vid_Show_Mario(false);
                        Inc(iMarioY);
                        Vid_Show_Mario(true);

                        Snd_Play(pfs_step1);

                        iNextMove := 0;
                      end;
              end;
           5: Gam_Mario_Jumps_Up;                                                 // jump up
           6: Gam_Mario_Jumps_Left;                                               // jump left
           7: Gam_Mario_Jumps_Right;                                              // jump right
           8: Gam_Mario_Jumps_Up;                                                 // jump up, even though joystick is pulled down
           9: Gam_Mario_Jumps_Up;                                                 // jump up, even though joystick is pulled up
        end; // case..of

        Timer_Mario_Move.Interval := 300;
       end;
    2: Gam_Mario_Moved;                                                         // phase 2
    3: begin                                                                    // phase 3 (in case Mario jumped)
         // Mario jumped
         Vid_Show_Mario(false);
         Dec(iMarioY);
         Vid_Show_Mario(true);

         Gam_Mario_Moved;
       end;
  end; // case..of

  if bMiss then                                                                 // miss check
    Gam_Do_Miss;
end;





procedure TForm1.Timer_Stage_CompleteTimer(Sender: TObject);
{ plays sound sample, then initializes a new stage                             }
begin
  case iLoopStageComplete of
    1: begin
         Vid_Show_Panel_Score(iScore);
         im_panel_bonus.Visible := false;
         Snd_Play(pfs_start2);

         iLoopStageComplete := 2;
         Timer_Stage_Complete.Interval := 3700;
       end;
    2: begin
         Gam_Init_Stage;

         Timer_Stage_Complete.Enabled := false;
       end;
  end; // case..of
end;





procedure TForm1.Timer_Time_CounterTimer(Sender: TObject);
{ plays "hurry up" 40 seconds past stage start, then goes into "miss"          }
begin
  case iLoopTimeCounter of
    400: begin                                                                  // 40 seconds past since stage start
           bController:=false;
           Snd_Silence;
           Snd_Play(pfs_hurryup);

           Timer_Game_1.Interval      := Timer_Game_1.Interval      + 10000;      // lenghtens timers a little bit
           Timer_Game_2.Interval      := Timer_Game_2.Interval      + 10000;
           Timer_Game_3.Interval      := Timer_Game_3.Interval      + 10000;
           Timer_Mario_Move.Interval  := Timer_Mario_Move.Interval  + 10000;
           Timer_Woman_Blink.Interval := Timer_Woman_Blink.Interval + 10000;
         end;
    415: begin                                                                  // "hurry up" has occured, goes continues for 5 more seconds
           Timer_Game_1.Interval      := Timer_Game_1.Interval      - 10000;      // resets timers to their previous duration
           Timer_Game_2.Interval      := Timer_Game_2.Interval      - 10000;
           Timer_Game_3.Interval      := Timer_Game_3.Interval      - 10000;
           Timer_Mario_Move.Interval  := Timer_Mario_Move.Interval  - 10000;
           Timer_Woman_Blink.Interval := Timer_Woman_Blink.Interval - 10000;
           bController := true;
         end;
     465: Gam_Do_Miss;                                                          // miss occurs. 46,5 seconds past since stage start
  end; // case..of

  Inc(iLoopTimeCounter);
end;





procedure TForm1.Timer_Woman_BlinkTimer(Sender: TObject);
{ woman shouts "HELP" at every few seconds                                     }
begin
  case iLoopWomanBlink of
    60: Vid_Show_Woman(2);                                                      // displays "HELP" at every 6 seconds
    63: Vid_Show_Woman(1);                                                      // hides "HELP"
  end; // case..of

  // loops action
  Inc(iLoopWomanBlink);

  if iLoopWomanBlink > 63 then
    iLoopWomanBlink := 0;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: POPUP MENU MANAGEMENT                                        * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.pm_0_menuPopup(Sender: TObject);
{ shows the "checked" menuitems if needed. also, hides the game menu if it is  }
{ visible when the popup menu pops up                                          }
begin
{}pm_11_splashscreen.Checked := iReg.ReadBool('', 'SplashScreen', SplashForm.chb_splashscreen.Checked);
{}pm_12_controller.Checked := bDisplayCtrlOverlays;

{}if bFullscreenMode
    and bGameMenuOpen then
    begin
      bGameMenuOpen := false;
      Form1.Vid_Display_Game_Menu(bGameMenuOpen);
    end;
end;





procedure TForm1.pm_1_aboutClick(Sender: TObject);
{ displays the embedded "About the author..." form                             }
begin
  AboutForm.Show;
end;





procedure TForm1.pm_2_readmeClick(Sender: TObject);
{ opens the "Readme.txt" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Readme.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_3_whatsnewClick(Sender: TObject);
{ opens the "Whatsnew.txt" file                                                }
begin
  ShellExecute(Handle, 'open', 'Whatsnew.txt', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_4_manualClick(Sender: TObject);
{ displays the embedded instructions manual                                    }
begin
  ManualForm.Show;
end;





procedure TForm1.pm_6_configClick(Sender: TObject);
{ opens the "Config.ini" file                                                  }
begin
  ShellExecute(Handle, 'open', 'Config.ini', nil, '', SW_SHOWNORMAL);
end;





procedure TForm1.pm_7_keysClick(Sender: TObject);
{ displays the "key settings" form                                             }
begin
  KeysForm.position := poScreenCenter;
  KeysForm.visible := true;
  Form1.Enabled := false;
end;





procedure TForm1.pm_8_hiscoreClick(Sender: TObject);
{ resets high scores to the system registry                                    }
begin
  iHiScore := 0; iReg.WriteInteger('', 'HiScore1', iHiScore);
  Beep;
end;





{}procedure TForm1.pm_10_fullscreenClick(Sender: TObject);
{ changes from fullscreen to windowed, and vice-versa                          }
begin
  // updates popup menu
  bFullscreenMode := not bFullscreenMode;
  pm_10_fullscreen.Checked := bFullscreenMode;
  bGameMenuOpen := false;

  iReg.WriteBool('', 'FullscreenMode', bFullscreenMode);

  // graphics init
  Top  := - Screen.Height;
  Left := - Screen.Width;
  Gfx_Game_Init;
  Position := poScreenCenter;
end;





procedure TForm1.pm_11_splashscreenClick(Sender: TObject);
{ updates the ticks to the checkbox, the popup menu and the system registry    }
begin
{}pm_11_splashscreen.Checked := not pm_11_splashscreen.Checked;

{}iReg.WriteBool('', 'SplashScreen', pm_11_splashscreen.Checked);
end;





procedure TForm1.pm_12_controllerClick(Sender: TObject);
{ displays the "tranlucent" controller overlay on the directional cross        }
begin
{}pm_12_controller.Checked := not pm_12_controller.Checked;
{}bDisplayCtrlOverlays := pm_12_controller.Checked;

{}iReg.WriteBool('', 'CtrlrOverlay', pm_12_controller.Checked);

  Form1.Vid_Display_Ctrl_Overlay;
end;





procedure TForm1.pm_14_exitClick(Sender: TObject);
{ exits the game                                                               }
begin
  Application.Terminate;
end;










{ **************************************************************************** }
{ *                                                                          * }
{ * PROCEDURES: GAME MENU MANAGEMENT                                         * }
{ *                                                                          * }
{ **************************************************************************** }

procedure TForm1.btn_game_menu_topClick(Sender: TObject);
{ sets the game menu as visible/hidden, then displays/hides it                 }
begin
  bGameMenuOpen := not bGameMenuOpen;
  Vid_Display_Game_Menu(bGameMenuOpen);
end;





procedure TForm1.la_menu_itemMouseEnter(Sender: TObject);
{ the game menu label bg colour becomes solid                                  }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := false;
end;





procedure TForm1.la_menu_itemMouseLeave(Sender: TObject);
{ the game menu label bg colour becomes transparent                            }
begin
  if Sender is TLabel then
    TLabel(Sender).Transparent := true;
end;





procedure TForm1.la_menu_itemMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{ hides the game menu, once a label has been pressed                           }
begin
  if Button = mbLeft then
    begin
      bGameMenuOpen := false;
      Vid_Display_Game_Menu(false);
    end;
end;





procedure TForm1.Vid_Display_Game_Menu(b: boolean);
{ displays/hides the game menu, depending on the value of bGameMenuOpen        }
  var
    i: integer;
begin
  case bGameMenuOpen of
    true: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i] := TLabel.Create(Form1);
            aMenuLabels[i].Parent := Form1;

            aMenuLabels[i].Top := 32 * i;
            aMenuLabels[i].Left := 0;

            aMenuLabels[i].AutoSize := false;
            aMenuLabels[i].Height := 32;
            aMenuLabels[i].Width := 256;
            aMenuLabels[i].Layout := tlCenter;

            aMenuLabels[i].Transparent := true;

            if aMenuItem[i].Caption <> '-' then
              begin
                aMenuLabels[i].Font.Name := 'Arial';
                aMenuLabels[i].Font.Color := clWhite;
                aMenuLabels[i].Font.Size := -12;
                aMenuLabels[i].Caption := '   ' + aMenuItem[i].Caption;

                if aMenuItem[i].Checked then
                  aMenuLabels[i].Caption := aMenuLabels[i].Caption + ' [V]';

                aMenuLabels[i].Color := $00000000;
                aMenuLabels[i].Cursor := crHandPoint;
                aMenuLabels[i].Enabled := aMenuItem[i].Enabled;

                if aMenuLabels[i].Enabled then
                  begin
                    aMenuLabels[i].OnClick      := aMenuItem[i].OnClick;
                    aMenuLabels[i].OnMouseEnter := la_menu_itemMouseEnter;
                    aMenuLabels[i].OnMouseLeave := la_menu_itemMouseLeave;
                    aMenuLabels[i].OnMouseUp    := la_menu_itemMouseUp;
                  end;
              end;
          end;

        btn_game_menu_background.Width := 256;
        btn_game_menu_background.Height := 32 * (MENU_ITEMS + 1)
      end;
    false: begin
        for i := 1 to MENU_ITEMS do
          begin
            aMenuLabels[i].Free;
          end;

        btn_game_menu_background.Height := 32;
        btn_game_menu_background.Width := 36;
      end;
    end; // case..of
end;





initialization
  bStartup := true;





end.
